// by Alexander Ilyin

#include "console.h"
#include "wx_colour_m.h"


wxRichTextCtrl* console_rich_text_ctrl = 0;
//wxWindow* console_window_dummy = 0;
wxColour console_background_colour_base;
// +++ config +++
bool console_autoscroll = 1;
// --- config ---

static va_list argptr;
#define VA_PRINTF \
	va_start (argptr, format); \
	wxString str; \
	str.PrintfV (format, argptr); \
	va_end (argptr);


// bad, the ctrl can be created only as child of some window, and cannot be standalone or child of a dummy window
void Console_Create (wxWindow* parent)
{
//	console_window_dummy = new wxWindow (0, wxID_ANY);
//	console_rich_text_ctrl = new wxRichTextCtrl;
//	console_rich_text_ctrl->Create (0);
//	console_rich_text_ctrl = new wxRichTextCtrl (console_window_dummy);
//	console_rich_text_ctrl = new wxRichTextCtrl (parent);
	console_rich_text_ctrl = new wxRichTextCtrl (parent, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxRE_MULTILINE | wxTE_READONLY);
}

void Console_Init ()
{
//	bool result;
	wxRichTextAttr rich_text_attr;
	wxColour colour;

	colour = wxColour (192, 192, 192);
	console_background_colour_base = colour;
// set for the whole window
	console_rich_text_ctrl->SetBackgroundColour (colour);

//	rich_text_attr.GetFlags ();
	rich_text_attr.SetBackgroundColour (colour);
// even no need to set line spacing now - it already becomes normal, once 'SetBasicStyle ()' has been requested
//	rich_text_attr.SetLineSpacing (10);
//	result = console_rich_text_ctrl->BeginLineSpacing (40);
	rich_text_attr.SetFontSize (10);
	console_rich_text_ctrl->SetBasicStyle (rich_text_attr);

// remove previously used effects
	rich_text_attr.SetFlags (0);

// always black font colour
	colour = wxColour (0, 0, 0);
	rich_text_attr.SetTextColour (colour);
// no colours
//	console_rich_text_ctrl->SetDefaultStyle (text_attr_ex);
	console_rich_text_ctrl->SetAndShowDefaultStyle (rich_text_attr);
//	console_rich_text_ctrl->SetBasicStyle (rich_text_attr);
}

void Console_Test ()
{
	Console_Notify ("Test string :  %s", "Notify");
	Console_Warning ("Test string :  %s", "Warning");
	Console_Error ("Test string :  %s", "Error");
	Console_ProgramError ("Test string :  %s", "Program error");
}

// seems have to handle the autoscroll myself
void Console_ScrollToEnd ()
{
//	uint pos_y;

// long tests, and nothing good
//	pos_y = console_rich_text_ctrl->GetScrollRange (wxVERTICAL);
// test
//	pos_y /= 2;
//	pos_y -= 20;
	console_rich_text_ctrl->Scroll (0, 1000000);
//	console_rich_text_ctrl->Scroll (0, pos_y);
//	console_rich_text_ctrl->Scroll (-1, pos_y);
// *looks buggied
//	console_rich_text_ctrl->SetScrollPos (wxVERTICAL, pos_y);
}

// informative message
void Console_Notify (const char* format, ...)
{
	wxColourM colour;
	wxRichTextAttr rich_text_attr;

	VA_PRINTF;
	colour = console_background_colour_base;
// green tint
	colour.Add (-16, 32, -16);
	rich_text_attr.SetBackgroundColour (colour);
	console_rich_text_ctrl->SetAndShowDefaultStyle (rich_text_attr);
	console_rich_text_ctrl->AppendText (str);
	console_rich_text_ctrl->AppendText ("\n");
	if (console_autoscroll)
		Console_ScrollToEnd ();
}

// something may be wrong
void Console_Warning (const char* format, ...)
{
	wxColourM colour;
	wxRichTextAttr rich_text_attr;

	VA_PRINTF;
	colour = console_background_colour_base;
// yellow tint
	colour.Add (16, 16, -32);
	rich_text_attr.SetBackgroundColour (colour);
	console_rich_text_ctrl->SetAndShowDefaultStyle (rich_text_attr);
	console_rich_text_ctrl->AppendText (str);
	console_rich_text_ctrl->AppendText ("\n");
}

// something unsucceed
void Console_Error (const char* format, ...)
{
	wxColourM colour;
	wxRichTextAttr rich_text_attr;

	VA_PRINTF;
	colour = console_background_colour_base;
// red tint
	colour.Add (32, -16, -16);
	rich_text_attr.SetBackgroundColour (colour);
	console_rich_text_ctrl->SetAndShowDefaultStyle (rich_text_attr);
	console_rich_text_ctrl->AppendText (str);
	console_rich_text_ctrl->AppendText ("\n");
}

void Console_ProgramError (const char* format, ...)
{
	wxColourM colour;
	wxRichTextAttr rich_text_attr;

	VA_PRINTF;
	colour = console_background_colour_base;
// purple tint
	colour.Add (16, -32, 16);
	rich_text_attr.SetBackgroundColour (colour);
	console_rich_text_ctrl->SetAndShowDefaultStyle (rich_text_attr);
	console_rich_text_ctrl->AppendText (str);
	console_rich_text_ctrl->AppendText ("\n");
}

