// by Alexander Ilyin

#include "dialog_file_properties.h"
#include "wx/button.h"
//#include "wx/valtext.h"
#include "wx/valgen.h"
#include "wx/stattext.h"
#include "wx/tooltip.h"
#include "console.h"
//#include <windows.h>


#define DIALOG_FILE_PROPERTIES__CONTROL_HEIGHT 16

#define DIALOG_FILE_PROPERTIES__SIZE_X_STATICTEXT 100
#define DIALOG_FILE_PROPERTIES__SIZE_X_CONTROLS 100
#define DIALOG_FILE_PROPERTIES__Y_INDENT 7


BEGIN_EVENT_TABLE(DialogFileProperties, wxDialog)
	EVT_BUTTON(wxID_OK, DialogFileProperties::OnOk)
	EVT_CHOICE(wxID_ANY, DialogFileProperties::OnChoice)
	EVT_TEXT(wxID_ANY, DialogFileProperties::OnText)
END_EVENT_TABLE()


DialogFileProperties::DialogFileProperties (wxWindow* window_parent, File* file)
:
// hmmm, how to get this indent
//wxDialog (window_parent, wxID_ANY, _T("File properties"), wxDefaultPosition,
//	wxSize (DIALOG_FILE_PROPERTIES__SIZE__X + SIZE_BORDER, DIALOG_FILE_PROPERTIES__SIZE__Y + SIZE_BORDER + SIZE_CAPTION),
//	wxDEFAULT_DIALOG_STYLE)
DialogWithButtons (window_parent, _T("File properties"), wxVERTICAL, "DialogFileProperties")
{
	int i_result;
	wxString str_initial;
	wxArrayString strings_array;
	int i;
//	wxSize ctrl_size_statictext;
	wxSize ctrl_size_choicebox;
	const char* string;
	int control_height;
//	int pos_x;
//	int pos_y;
	int y_indent;

	m_file = file;

//	ctrl_size_statictext = wxSize (DIALOG_FILE_PROPERTIES__SIZE_X_STATICTEXT, DIALOG_FILE_PROPERTIES__CONTROL_HEIGHT);
// only x acts
	ctrl_size_choicebox = wxSize (DIALOG_FILE_PROPERTIES__SIZE_X_CONTROLS, DIALOG_FILE_PROPERTIES__CONTROL_HEIGHT);
	control_height = DIALOG_FILE_PROPERTIES__CONTROL_HEIGHT;
	y_indent = DIALOG_FILE_PROPERTIES__Y_INDENT;

	m_choice_format = new wxChoice (this, wxID_ANY,
		wxDefaultPosition, ctrl_size_choicebox, 0, 0);
	m_choice_id__format = m_choice_format->GetId ();
// populate the list
	i = 1;
	while (File::GetFormatName (i, &string))
	{
//		str.Printf ("%s", string);
//		m_choice_format->Append (str);
		m_choice_format->Append (string);
		i++;
	}

	m_format = m_file->m_info.format;
	m_subformat = m_file->m_info.subformat;
	wxASSERT(m_format > 0);
	wxASSERT(m_format < i);

// make zero based
	m_choice_format->Select (m_format - 1);

	m_choice_subformat = new wxChoice (this, wxID_ANY,
		wxDefaultPosition, ctrl_size_choicebox, 0, 0);
	m_choice_id__subformat = m_choice_subformat->GetId ();
	int m_choice_id__samplerate;
	int m_choice_id__bits_per_sample;
//	m_choice_subformat->Select (0);
//	m_choice_subformat->Enable (with_subformat);
//	PopulateChoiceBox_Subformat (m_file->m_format);
	PopulateChoiceBox_Subformat ();

// **forget this validator, and make later own testing subr.
// todo :  dynamic validator, to disallow "." input when the value must be integer

// it is full mathematics-numeric validator (not good for this case)
// strange, 'wxTextValidator' suddenly become throwing assertion on non 'wxTextCtrl'; I only changed parent to 'this' instead of 'm_panel'
//	wxTextValidator validator (wxFILTER_NUMERIC);
//	wxTextValidator validator (wxFILTER_INCLUDE_CHAR_LIST);
//	wxString validator_string = "12345";
//	wxGenericValidator validator (&validator_string);
	strings_array.Empty ();
	for (i = 0; i < 10; i++)
		strings_array.Add ((char)('0' + i));
// have to exclude doublepoints ...
	strings_array.Add ('.');
//	wxGenericValidator validator (strings_array);
//	validator.SetIncludes (strings_array);
	str_initial.Printf ("%u", m_file->m_info.samples_per_sec);
//	strings_array.Empty ();
// if giving array, then the size decreases (from default) to the width of widest array element
// not depends on initial string width in any way
	m_combobox_samplerate = new wxComboBox (this, wxID_ANY, str_initial,
//		wxDefaultPosition, ctrl_size_choicebox, 0, 0, validator);
		wxDefaultPosition, ctrl_size_choicebox);
	m_choice_id__samplerate = m_combobox_samplerate->GetId ();
	m_samplerate = m_file->m_info.samples_per_sec;
	PopulateChoiceBox_SampleRate ();

	m_choice_bits_per_sample = new wxChoice (this, wxID_ANY,
		wxDefaultPosition, ctrl_size_choicebox, 0, 0);
	m_choice_id__bits_per_sample = m_choice_bits_per_sample->GetId ();
	PopulateChoiceBox_BitsPerSample ();

// + sizers +
	wxBoxSizer* sizer_type;
	wxBoxSizer* sizer_subformat;
	wxBoxSizer* sizer_samplerate;
	wxBoxSizer* sizer_bps;

	CreateSizerWithControlAndLabel_Horizontally (&sizer_type, m_choice_format, _T("File type :"), wxALL, y_indent);
	CreateSizerWithControlAndLabel_Horizontally (&sizer_subformat, m_choice_subformat, _T("File subformat :"), wxALL, y_indent);
	CreateSizerWithControlAndLabel_Horizontally (&sizer_samplerate, m_combobox_samplerate, _T("Sample rate :"), wxALL, y_indent);
	CreateSizerWithControlAndLabel_Horizontally (&sizer_bps, m_choice_bits_per_sample, _T("Bits per sample :"), wxALL, y_indent);
// - sizers -

// every allowed to grow
	m_sizer_contain->Add (sizer_type, 1, wxEXPAND);
	m_sizer_contain->Add (sizer_subformat, 1, wxEXPAND);
	m_sizer_contain->Add (sizer_samplerate, 1, wxEXPAND);
	m_sizer_contain->Add (sizer_bps, 1, wxEXPAND);
//	m_sizer_contain->Layout ();
//	m_sizer_contain->RecalcSizes ();

	m_is_data_valid = 1;

//	AppendMainButtons ();
	SetSizerAndButtons ();

	i_result = ShowModal ();
	if (i_result != wxID_OK)
		return;

	ReadControlsValues ();
}

// *not clears the list; enables/disables the list
//void DialogFileProperties::PopulateChoiceBox_Subformat (int format_ix)
void DialogFileProperties::PopulateChoiceBox_Subformat ()
{
	bool with_subformat;
//	bool result;
	int i;
	int tag;
	const char* string;
	wxString str;
//	int subformat;

	with_subformat = File::HaveSubformat (m_format);
// grey it, if not in use
	m_choice_subformat->Enable (with_subformat);
	if (! with_subformat)
		return;

// populate the list
	i = 1;
	while (File::GetSubformatInfo (m_format, i, &tag, &string))
	{
		str.Printf ("%02x - %s", tag, string);
		m_choice_subformat->Append (str);
		i++;
	}

	wxASSERT(m_subformat);
	wxASSERT(m_subformat < i);
// make zero based
	m_choice_subformat->SetSelection (m_subformat - 1);
}

//void DialogFileProperties::PopulateChoiceBox_SampleRate (int format_ix, int subformat_ix)
void DialogFileProperties::PopulateChoiceBox_SampleRate ()
{
	bool have_samplerate;
	bool can_be_modified;
	bool samplerate_is_valid;
//	int samplerate;
	wxString str;

	have_samplerate = File::HaveSamplerate (&can_be_modified, m_format, m_subformat);
// greyout, if nothing to select or no optional selections
	m_combobox_samplerate->Enable (can_be_modified);
	if (! have_samplerate)
		return;

// + defined value +
//	samplerate = m_samplerate_backup;
	samplerate_is_valid = File::IsSamplerateValid (m_format, m_subformat, m_samplerate);
	if (! samplerate_is_valid)
		File::GetDefaultSamplerate (m_format, m_subformat, &m_samplerate);
	str.Printf ("%u", m_samplerate);
	m_combobox_samplerate->SetValue (str);
// and maybe this also
//	m_combobox_samplerate->SetSelection ();
// - defined value -
	if (! can_be_modified)
		return;

// + listed values +
// don't offer nonstandard crappy rates here
	m_combobox_samplerate->Append ("8000");
	m_combobox_samplerate->Append ("11025");
	m_combobox_samplerate->Append ("16000");
	m_combobox_samplerate->Append ("22050");
	m_combobox_samplerate->Append ("44100");
	m_combobox_samplerate->Append ("48000");
// for cats :) (will not be enough actually :), 60khz the limit is iirc)
	m_combobox_samplerate->Append ("96000");
// - listed values -
}

//void DialogFileProperties::PopulateChoiceBox_BitsPerSample (int format_ix, int subformat_ix)
void DialogFileProperties::PopulateChoiceBox_BitsPerSample ()
{
	int ix;
	int bps;
	wxString str;
	int file_have_bps_ix = -1;
	bool have_choices;

// "input of custom value is not offered, because the program will not know how to store waves for such rate then"
	ix = 0;
	while (File::GetIndexedBitsPerSampleInfo (m_format, m_subformat, ix, &bps))
	{
		str.Printf ("%u", bps);
		m_choice_bits_per_sample->Append (str);
		if (bps == m_file->m_info.bits_per_sample)
			file_have_bps_ix = ix;
		ix++;
	}
	wxASSERT(ix >= 1);
	if (file_have_bps_ix < 0)
	{
		Console_ProgramError ("DialogFileProperties::PopulateChoiceBox_BitsPerSample () :  file have %u bits per sample; no such value in list", m_file->m_info.bits_per_sample);
		return;
	}
// turn off, if nowhere from to select
	have_choices = ix > 1;
	m_choice_subformat->Enable (have_choices);
	m_choice_bits_per_sample->SetSelection (file_have_bps_ix);
}

// user confirmed to make changes
// mark file's 'have_changes' anyway
void DialogFileProperties::ReadControlsValues ()
{
	bool result;
	bool with_subformat;
	int format;
	int subformat;
	ulong samplerate;
	wxString str;

// make one based
	format = m_choice_format->GetSelection () + 1;
	m_file->m_info.format = format;
	with_subformat = m_file->HaveSubformat ();

//	subformat = 0;
	if (! with_subformat)
		goto read_samplerate;
	subformat = m_choice_subformat->GetSelection () + 1;
	m_file->m_info.subformat = subformat;

read_samplerate:
	str = m_combobox_samplerate->GetValue ();
//	result = str.ToULong (&m_file->m_info.samples_per_sec);
// allow hexadecimal input
	result = str.ToULong (&samplerate, 0);
	if (result)
	{
		m_file->SetSampeRate (samplerate);
	}
}

// still, the argument may be not necessary
bool DialogFileProperties::Read_SampleRate (uint* samplerate)
{
	bool result;
	wxString str;
	ulong rate;

	str = m_combobox_samplerate->GetValue ();
// allow hexadecimal input
// result is 0, if string is empty or have letters
	result = str.ToULong (&rate, 0);
	if (result)
		*samplerate = rate;
	return result;
}

bool DialogFileProperties::Read_SampleRate ()
{
	bool result;

	result = Read_SampleRate (&m_samplerate);
	return result;
}

// necessary ?
#if 0
void DialogFileProperties::SampleRate_Set (int rate)
{
	m_samplerate = rate;
}
#endif

// hehe, this becomes unnecessary
#if 0
void DialogFileProperties::SampleRate_Backup ()
{
//	uint rate;
	bool result;

//	result = Read_SampleRate (&rate);
	result = Read_SampleRate ();
// maybe also check does it valid (?), but that would require to read format and subformat values
//	if (! result)
//		return;
//	m_samplerate = rate;
}
#endif

bool DialogFileProperties::Read_BitsPerSample ()
{
	bool result;
	wxString str;
	ulong rate;

	str = m_choice_bits_per_sample->GetStringSelection ();
// allow hexadecimal input
// result is 0, if string is empty or have letters
	result = str.ToULong (&rate, 0);
	if (result)
		m_bits_per_sample = rate;
	return result;
}

// validate data
// considering, that 'm_format' and 'm_subformat' changes has been defined by 'OnChoice ()'
void DialogFileProperties::OnText (wxCommandEvent& event)
{
	bool samplerate_can_be_modified;
	bool is_valid_samplerate = 1;
	bool is_valid_bps = 1;
//	bool is_valid = 1;
	uint samplerate;
	bool result;

	File::HaveSamplerate (&samplerate_can_be_modified, m_format, m_subformat);
	if (! samplerate_can_be_modified)
		goto check_bps;
	result = Read_SampleRate (&samplerate);
	if (! result)
	{
		is_valid_samplerate = 0;
		goto check_bps;
	}
	is_valid_samplerate = File::IsSamplerateValid (m_format, m_subformat, samplerate);

check_bps:
// with bps isn't clear yet; no 'File' subroutines yet
// actually, here cannot be invalid input; atm - no ability to make invalid selection
	;

//	ShowWrongValue_SampleRate (! is_valid_samplerate);
//	ShowWrongValue_BitsPerSample (! is_valid_bps);
	SetBackgroundValidnessColour (m_combobox_samplerate, is_valid_samplerate);
	SetBackgroundValidnessColour (m_choice_bits_per_sample, is_valid_bps);

//	m_is_data_valid = is_valid;
	m_is_data_valid = is_valid_samplerate && is_valid_bps;
}

// when something is chosen, at that depending items must be checked in this order :
// 1) use current string if it will be valid for a new format
// (that will prevent of resetting of subsettings when choosing the same punkt; not for subformat subsetting)
// 2) use file current subsettings, if a setting has become the same as in the file
// 3) use default value
// bad, such multicomponent system will make user messed, it is better to avoid step 2
void DialogFileProperties::OnChoice (wxCommandEvent& event)
{
	int id;
	int ix;
//	int format_ix;
//	int subformat_ix;
	bool result;

	Read_SampleRate ();

// for the format chose - repopulate subformat, samplerate and bps
// for the subformat chose - repopulate samplerate and bps
// for the samplerate and bps choises - no need repopulate

	id = event.GetId ();
	if (id == m_choice_id__samplerate || id == m_choice_id__bits_per_sample)
		goto finish;
	if (id == m_choice_id__subformat)
		goto repopulate_samplerate_and_bps;
	if (id != m_choice_id__format)
		goto finish;

// choosing format
	ix = m_choice_format->GetSelection ();
// make 1 based
//	format_ix = ix + 1;
	m_format = ix + 1;
// offer default selection
	if (m_format == m_file->m_info.format)
		m_subformat = m_file->m_info.subformat;
	else
// always offer default
// it will be hard mess to manage, if some formats will have the same optional subformats
	{
		result = File::GetDefaultSubformat (m_format, &m_subformat);
//		wxASSERT(result);
	}

	m_choice_subformat->Clear ();
//	PopulateChoiceBox_Subformat (format_ix);
	PopulateChoiceBox_Subformat ();

repopulate_samplerate_and_bps:
// here not setting selected value, using existing value instead
// and for the samplerate - using backed up value, because the string may be empty in some cases
	m_combobox_samplerate->Clear ();
	m_choice_bits_per_sample->Clear ();
//	m_choice_subformat->SetSelection (wxNOT_FOUND);
//	PopulateChoiceBox_SampleRate (format_ix, subformat_ix);
//	PopulateChoiceBox_BitsPerSample (format_ix, subformat_ix);
	PopulateChoiceBox_SampleRate ();
// todo
// bytespersample also
	PopulateChoiceBox_BitsPerSample ();

finish:
// this theoretically must be at exit, but placed here for symmetry
	Read_BitsPerSample ();

	event.Skip ();
}

void DialogFileProperties::OnOk (wxCommandEvent& event)
{
	if (! m_is_data_valid)
		return;

	m_file->m_info.format = m_format;
	m_file->m_info.subformat = m_subformat;
//	m_file->m_info.bits_per_sample = m_bits_per_sample;
//	m_file->m_bytes_per_sample = m_bits_per_sample >> 3;
//	m_file->m_info.samples_per_sec = m_samplerate;
	m_file->SetBitsPerSample (m_bits_per_sample);
	m_file->SetSampeRate (m_samplerate);
	m_file->m_have_changes = 1;
// allow to exit
	event.Skip ();
}

