#pragma once

//#include "wx/dialog.h"
#include "dialog_with_buttons.h"
#include "file.h"
#include "wx/combobox.h"


class DialogFileProperties : public DialogWithButtons
{
public:
	DialogFileProperties::DialogFileProperties (wxWindow* window_parent, File* file);
private:
// these aren't just populating, but also they are defining ctrl activity
//	void PopulateChoiceBox_Subformat (int format_ix);
//	void PopulateChoiceBox_SampleRate (int format_ix, int subformat_ix);
//	void PopulateChoiceBox_BitsPerSample (int format_ix, int subformat_ix);
	void PopulateChoiceBox_Subformat ();
	void PopulateChoiceBox_SampleRate ();
	void PopulateChoiceBox_BitsPerSample ();
//	void DefineValue_Subformat ();
//	void DefineValue_SampleRate ();
//	void DefineValue_BitsPerSample ();
	void ReadControlsValues ();
	bool Read_SampleRate (uint* samplerate);
	bool Read_SampleRate ();
	bool Read_BitsPerSample ();
//	void SampleRate_Set (int rate);
//	void SampleRate_Backup ();
	void OnText (wxCommandEvent& event);
	void OnChoice (wxCommandEvent& event);
	void OnOk (wxCommandEvent& event);

private:
	File* m_file;
	wxChoice* m_choice_format;
	wxChoice* m_choice_subformat;
	wxComboBox* m_combobox_samplerate;
	wxChoice* m_choice_bits_per_sample;
	int m_choice_id__format;
	int m_choice_id__subformat;
	int m_choice_id__samplerate;
	int m_choice_id__bits_per_sample;
// better way to transfer data between subroutines
// these not needs to be equal to current choose, it is just variables for transfer,
// which helps to exclude additional arguments for functions
	int m_format;
	int m_subformat;
//	int m_samplerate;
	uint m_samplerate;
	uint m_bits_per_sample;
	bool m_is_data_valid;

	DECLARE_EVENT_TABLE()
};

