// inserting/removing of samples dialog
// for use with both - files and waves
// do not add "by time" here, make selectability by time in the editor instead

#include "dialog_samples.h"


//BEGIN_EVENT_TABLE(DialogSamples, wxDialog)
BEGIN_EVENT_TABLE(DialogSamples, DialogWithButtons)
	EVT_BUTTON(wxID_OK, DialogSamples::OnOk)
	EVT_TEXT(wxID_ANY, DialogSamples::OnText)
END_EVENT_TABLE()


#if 0
DialogSamples::DialogSamples (wxWindow* window_parent, const wxString& title, long style, const wxString& name)
//:
//wxDialog (window_parent, wxID_ANY, title, wxDefaultPosition, wxDefaultSize, style, name)
//DialogWithButtons (window_parent, title, wxVERTICAL, wxOK | wxCANCEL, style, name)
{
//	m_is_file = 1;
}
#endif

#if 0
DialogSamples::DialogSamples (wxWindow* window_parent, File* file, char* title)
:
DialogWithButtons (window_parent, title, wxVERTICAL, "DialogSamples")
{
	m_file = file;
	m_proj = 0;
	m_is_file = 1;
//	DialogSamples (window_parent, title);
	Init ();
}

//DialogSamples::DialogSamples (wxWindow* window_parent, Wave* wave, char* title)
DialogSamples::DialogSamples (wxWindow* window_parent, Project* proj, char* title)
:
DialogWithButtons (window_parent, title, wxVERTICAL, "DialogSamples")
{
	m_file = 0;
	m_proj = proj;
	m_is_file = 0;
	m_is_insert = is_insert;
//	DialogSamples (window_parent, title);
	Init ();
}
#endif

DialogSamples::DialogSamples (wxWindow* window_parent, char* title, bool is_insert)
:
DialogWithButtons (window_parent, title, wxVERTICAL, "DialogSamples")
{
	m_is_insert = is_insert;
	Init ();
}

DialogSamples::~DialogSamples ()
{
//	delete m_textctrl_offset;
//	delete m_textctrl_samples_num;
}

void DialogSamples::Init ()
{
//	wxTextValidator* text_validator;
	wxValidator* validator;
	wxBoxSizer* sizer_samples_show_num;
	wxBoxSizer* sizer_offset;
	wxBoxSizer* sizer_samples_num;

#if 0
	int y_indent;
	char* default_value;
	wxSize ctrl_size;

	ctrl_size = wxSize (100, 16);
	default_value = "-----";
//	m_textctrl_samples_show_num = new wxTextCtrl (this, wxID_ANY, default_value, wxDefaultPosition, ctrl_size, wxTE_READONLY, wxDefaultValidator, "DialogSamples::m_textctrl_samples_show_num");
	m_textctrl_samples_show_num = new wxTextCtrl (this, wxID_ANY, default_value, wxDefaultPosition, ctrl_size);
//	text_validator = new wxTextValidator (wxFILTER_NUMERIC);
	validator = new wxTextValidator (wxFILTER_NUMERIC);
	if (m_is_insert)
		default_value = "-1";
	else
		default_value = "0";
//	m_textctrl_offset = new wxTextCtrl (this, wxID_ANY, "-1", wxDefaultPosition, ctrl_size, 0, text_validator, "DialogSamples::m_textctrl_offset");
	m_textctrl_offset = new wxTextCtrl (this, wxID_ANY, default_value, wxDefaultPosition, ctrl_size, 0, *validator, "DialogSamples::m_textctrl_offset");
//	text_validator = new wxTextValidator (wxFILTER_NUMERIC);
	validator = new wxTextValidator (wxFILTER_NUMERIC);
	if (m_is_insert)
		default_value = "";
	else
		default_value = "-1";
//	m_textctrl_samples_num = new wxTextCtrl (this, wxID_ANY, "-1", wxDefaultPosition, ctrl_size, 0, text_validator, "DialogSamples::m_textctrl_offset");
	m_textctrl_samples_num = new wxTextCtrl (this, wxID_ANY, default_value, wxDefaultPosition, ctrl_size, 0, *validator, "DialogSamples::m_textctrl_samples_num");

	y_indent = 7;
	CreateSizerWithControlAndLabel_Horizontally (&sizer_samples_show_num, m_textctrl_samples_show_num, _T("Samples number :"), wxALL, y_indent);
	if (m_is_insert)
	{
		CreateSizerWithControlAndLabel_Horizontally (&sizer_offset, m_textctrl_offset, _T("Offset (-1 - at file end) :"), wxALL, y_indent);
		CreateSizerWithControlAndLabel_Horizontally (&sizer_samples_num, m_textctrl_samples_num, _T("Samples number to insert :"), wxALL, y_indent);
	}
	else
	{
		CreateSizerWithControlAndLabel_Horizontally (&sizer_offset, m_textctrl_offset, _T("Offset :"), wxALL, y_indent);
		CreateSizerWithControlAndLabel_Horizontally (&sizer_samples_num, m_textctrl_samples_num, _T("Samples number to remove (-1 - all which remain) :"), wxALL, y_indent);
	}
#else
	TCHAR* tstr;

// looks like some disharmony :  (-1, -1) for the vertical, and a defined for the horizontal
	m_defparam_ctrl_size_textctrl = wxSize (100, 16);
// is really really bad
//	CreateSizerWithTextAndLabel_Horizontally (&sizer_samples_show_num, &m_textctrl_samples_show_num, _T("Samples number :"));
// still is not obvious
//	CreateSizerWithTextAndLabel_Horizontally (&sizer_samples_show_num, &m_textctrl_samples_show_num, _T("Samples number in the wave :"));
// too long
//	CreateSizerWithTextAndLabel_Horizontally (&sizer_samples_show_num, &m_textctrl_samples_show_num, _T("Total samples number in the wave :"));
// maybe; the string now completely differs from the next lines, so is visually separated
// I would create a separate TextCtrlPassive control for that, that it would be greyed, and be selectable, but perhaps no need, since a user primarily needs to enter the offset, and not to copy/paste the total samples amount;
// so atm it will be just read-only and of a grey background colour
// WX atm makes a window greyed only for a disabled window, a content of which cannot be selected at all; that is not permissible (acceptible)
//	CreateSizerWithTextAndLabel_Horizontally (&sizer_samples_show_num, &m_textctrl_samples_show_num, _T("Total samples in the wave :"));
// *losses the window selectability by tab key
	CreateSizerWithTextAndLabel_Horizontally (&sizer_samples_show_num, &m_textctrl_samples_show_num, _T("Total samples in the wave :"), wxTE_READONLY);
// nothing gives
//	CreateSizerWithTextAndLabel_Horizontally (&sizer_samples_show_num, &m_textctrl_samples_show_num, _T("Total samples in the wave :"), wxTE_READONLY | wxTAB_TRAVERSAL);
//	CreateSizerWithTextAndLabel_Horizontally (&sizer_samples_show_num, &m_textctrl_samples_show_num, _T("Total samples in the wave :"), wxTE_READONLY | wxWANTS_CHARS);
// greyed
//	m_textctrl_samples_show_num->Enable (0);
	if (m_is_insert)
		tstr = _T("Offset (-1 - at file end) :");
	else
		tstr = _T("Offset :");
	CreateSizerWithTextAndLabel_Horizontally (&sizer_offset, &m_textctrl_offset, tstr);
	if (m_is_insert)
		tstr = _T("Samples number to insert :");
	else
		tstr = _T("Samples number to remove (-1 - all which remain) :");
	CreateSizerWithTextAndLabel_Horizontally (&sizer_samples_num, &m_textctrl_samples_num, tstr);
#endif

	validator = new wxTextValidator (wxFILTER_NUMERIC);
	m_textctrl_offset->SetValidator (*validator);
	validator = new wxTextValidator (wxFILTER_NUMERIC);
	m_textctrl_samples_num->SetValidator (*validator);

	m_checkbox_update_file = new wxCheckBox (this, wxID_ANY, _T("Update file information"));
//	m_checkbox_update_file = new wxCheckBox (this, wxID_ANY, _T("Update file information"),
//		wxDefaultPosition, wxDefaultSize, wxALIGN_RIGHT);

	m_sizer_contain->Add (sizer_samples_show_num, 1, wxEXPAND);
	m_sizer_contain->Add (sizer_offset, 1, wxEXPAND);
	m_sizer_contain->Add (sizer_samples_num, 1, wxEXPAND);
	m_sizer_contain->Add (m_checkbox_update_file, 1, wxALIGN_CENTRE_HORIZONTAL);

// *'wxTE_READONLY' has taken off the focus from the necessary element; restore it back
// *and 'SetFocus ()' does loss the selection, if the selection is made
//	m_textctrl_samples_show_num->SetFocus ();
//	m_textctrl_samples_show_num->SetFocusFromKbd ();
// restores everything back; not what I need
// (although people just recommend to use 'wxPanel')
//	m_textctrl_samples_show_num->SetEditable (1);
//	m_textctrl_samples_show_num->SetEditable (0);

	SetSizerAndButtons ();
}

bool DialogSamples::Invoke (bool have_common_samples_num, uint64 common_samples_num)
{
//	bool result;
	int i_result;
	wxString str;
//	uint64 i64;
	TCHAR* tstr;

	m_have_common_samples_num = have_common_samples_num;
	if (have_common_samples_num)
	{
		m_common_samples_num = common_samples_num;
		str.Printf (_T("%llu"), common_samples_num);
		m_textctrl_samples_show_num->ChangeValue (str);
	}
	if (m_is_insert)
		tstr = _T("-1");
	else
		tstr = _T("");
	m_textctrl_offset->ChangeValue (tstr);
	if (m_is_insert)
		tstr = _T("");
	else
		tstr = _T("-1");
	m_textctrl_samples_num->ChangeValue (tstr);
	m_checkbox_update_file->SetValue (1);
// validate values
	ReadValues ();

// no need; I don't need that control to be active and its text to be selected
#if 0
// *'wxTE_READONLY' has taken off the focus from the necessary element; restore it back
// restore the selection back
// ergh, not works
//	::SendMessage ((HWND)m_textctrl_samples_show_num->GetHandle(), EM_SETSEL, 0, 2);
// try to deselect
//	::SendMessage ((HWND)m_textctrl_samples_show_num->GetHandle(), EM_SETSEL, -1, 0);
// hmmm, this works
//	::SendMessage ((HWND)m_textctrl_samples_show_num->GetHandle(), EM_SETREADONLY, 1, 0);
// and this does not change; perhaps WX will still set an own selection
//	m_textctrl_samples_show_num->SetSelection (0, 2);
#endif
	SetBackgroundColour_Passive (m_textctrl_samples_show_num);

	i_result = ShowModal ();
	if (i_result != wxID_OK)
		return 0;
	return 1;
}

// read and validate data
void DialogSamples::ReadValues ()
{
	bool result;
	int i_result;
	bool is_valid = 1;
	wxString str;

//	m_is_data_valid = 0;
	if (m_is_insert)
// insert
	{
		str = m_textctrl_offset->GetValue ();
		i_result = str.Cmp ("-1");
		if (! i_result)
		{
			result = !! m_have_common_samples_num;
			if (result)
// insert will be at the end
// *the end may be different for different waves
//				m_offset = m_common_samples_num;
				m_offset = -1;
			goto show_validness_offset;
		}
	}
//	result = str.ToULongLong (&m_offset);
	result = CtrlReadUInt64 (m_textctrl_offset, &m_offset);
	if (m_have_common_samples_num)
		if (result)
// allow also equal to the end value for the remove
			result = m_offset <= m_common_samples_num;
show_validness_offset:
	SetBackgroundValidnessColour (m_textctrl_offset, result);
	is_valid &= result;

	if (! m_is_insert)
// remove
	{
		str = m_textctrl_samples_num->GetValue ();
		i_result = str.Cmp ("-1");
		if (! i_result)
		{
			result = !! m_have_common_samples_num;
			if (result)
// from here until the end
// *the end may be different for different waves
//				m_samples_num = m_common_samples_num - m_offset;
				m_samples_num = -1;
			goto show_validness_samples_num;
		}
	}
//	result = str.ToULongLong (&m_samples_num);
	result = CtrlReadUInt64 (m_textctrl_samples_num, &m_samples_num);
show_validness_samples_num:
	SetBackgroundValidnessColour (m_textctrl_samples_num, result);
	is_valid &= result;
// zero num is meaningless in any case
	is_valid &= !! m_samples_num;

	m_update_file = m_checkbox_update_file->GetValue ();

	m_is_data_valid = is_valid;
}

void DialogSamples::OnText (wxCommandEvent& event)
{
	ReadValues ();
}

void DialogSamples::OnOk (wxCommandEvent& event)
{
	if (! m_is_data_valid)
		return;

// allow to exit
	event.Skip ();
}

