// abstract class :  dialog with the panel for controls and ok/cancel buttons on it
// *last version of 'dialog_ok_cancel' is in "36.zip"

#include "dialog_with_buttons.h"
#include "wx/button.h"
#include "wx/stattext.h"
#include "wx/settings.h"
#include "config.h"
#include "error.h"
//#include <string>
#include <sstream>
using namespace std;


//#define DIALOG_OK_CANCEL__INDENT_X 10
//#define DIALOG_OK_CANCEL__INDENT_Y 5

// make enough space between buttons, so that mistypes would be avoided
#define DIALOG_OK_CANCEL__SIZE__SPACE_BETWEEN_BUTTONS_X 70

//#define DIALOG_OK_CANCEL__INDENT_BUTTONS_ABOVE 20
//#define DIALOG_OK_CANCEL__INDENT_BUTTONS_BELOW 10

//#define STRINGIZE(_arg_) #_arg_
#define STRINGIZE2(_arg_) #_arg_
#define STRINGIZE(_arg_) STRINGIZE2(_arg_)
// not works
//#error (STRINGIZE(wxMAJOR_VERSION))
// good
//#pragma message("maj"STRINGIZE(wxMAJOR_VERSION))
//#pragma message("min"STRINGIZE(wxMINOR_VERSION))

// newer WX; can't say the exact trunk; in WX_2_9_0_BRANCH it is present, in WX_2_8_BRANCH it doesn't
#define WX_VER_BELOW_2 (wxMAJOR_VERSION < 2)
#define WX_VER_EQUAL_2 (wxMAJOR_VERSION == 2)
#if (WX_VER_BELOW_2 || (WX_VER_EQUAL_2 && (wxMINOR_VERSION < 9)))
#define wxSYS_COLOUR_FRAMEBK wxSYS_COLOUR_BTNFACE
#endif


// no size now, because it isn't known yet
// *button flags actually must go first, but I want to give ok/cancel default value to those buttons, and avoid of giving defvalue to orient
DialogWithButtons::DialogWithButtons (wxWindow* window_parent, const wxString& title, int sizer_orient, const wxString& name, long buttons_flags, long style)
:
//m_size (size),
// add place for Ok/Cancel buttons
//m_size_to_add (0, 20 + DIALOG_OK_CANCEL__SIZE__BUTTON_Y + 10),
//m_size_panel (m_size + m_size_to_add),
//DIALOG_FILE_PROPERTIES__SIZE__X + SIZE_BORDER, DIALOG_FILE_PROPERTIES__SIZE__Y + SIZE_BORDER + SIZE_CAPTION
// hmmm, how to get this indent
wxDialog (window_parent, wxID_ANY, title, wxDefaultPosition, wxDefaultSize, style, name)
{
	wxColourDiff colour_diff;

	m_buttons_flags = buttons_flags;

// == base parameters ==
// *not in use atm
	m_defparam_size_button_x = DIALOG_WITH_BUTTONS__SIZE__BUTTON_X;
	m_defparam_size_button_y = DIALOG_WITH_BUTTONS__SIZE__BUTTON_Y;
	m_defparam_space_between_buttons_x = DIALOG_OK_CANCEL__SIZE__SPACE_BETWEEN_BUTTONS_X;
//	m_defparam_indent_x = DIALOG_OK_CANCEL__INDENT_X;
//	m_defparam_indent_y = DIALOG_OK_CANCEL__INDENT_Y;
//	m_defparam_indent_buttons_above = DIALOG_OK_CANCEL__INDENT_BUTTONS_ABOVE;
//	m_defparam_indent_buttons_below = DIALOG_OK_CANCEL__INDENT_BUTTONS_BELOW;
//	m_defparam_ctrl_size_textctrl = wxSize (32, DIALOG_OK_CANCEL__SIZE__BUTTON_Y);
	m_defparam_ctrl_size_textctrl = wxDefaultSize;

// == colours ==
// make red tint
	colour_diff.Set (0, -40, -40);
//	m_colour_background = wxSystemSettings::GetColour (wxSYS_COLOUR_BACKGROUND);
// ordinary is white
	m_colour_background = wxSystemSettings::GetColour (wxSYS_COLOUR_WINDOW);
	m_colour_wrong_value = m_colour_background + colour_diff;
// this is so dark, so I think it is a foreground colour of a gray text
//	m_colour_passive = wxSystemSettings::GetColour (wxSYS_COLOUR_GRAYTEXT);
//	m_colour_passive = wxNullColour;
//	m_colour_passive = wxSystemSettings::GetColour (wxSYS_COLOUR_BACKGROUND);
//	m_colour_passive = wxSystemSettings::GetColour (wxSYS_COLOUR_INACTIVECAPTION);
// good, but that is too much passive :P
// although no, this colour is used as inactive everywhere; its value is near d4d0c8
//	m_colour_passive = wxSystemSettings::GetColour (wxSYS_COLOUR_MENU);
// black
//	m_colour_passive = wxSystemSettings::GetColour (wxSYS_COLOUR_WINDOWFRAME);
// same as wxSYS_COLOUR_MENU
// but I still think that it is an improper colour name; could get the necessary colour (of the same value) from os, while WX have no own
//	m_colour_passive = wxSystemSettings::GetColour (wxSYS_COLOUR_INACTIVECAPTIONTEXT);
//	m_colour_passive = wxSystemSettings::GetColour (wxSYS_COLOUR_BTNFACE);
	m_colour_passive = wxSystemSettings::GetColour (wxSYS_COLOUR_FRAMEBK);

// == sizers ==
	m_sizer_dialog = new wxBoxSizer (wxVERTICAL);
	m_sizer_buttons = new wxBoxSizer (wxHORIZONTAL);
// no, will need to create manually; this function even may be called not valid
//	m_sizer_buttons = CreateButtonSizer (buttons_flags);
	m_sizer_contain = new wxBoxSizer (sizer_orient);

//	m_sizer_buttons->Add ();
}

#if 0
// perhaps I had to use 'CreateButtonSizer ()', instead of manually defining

void DialogWithButtons::DefineAndSetSizes (int w, int h)
{
//	int size_x;
//	wxSize size_whole;

// buttons plus spaces
// (really - sizer actually exist for this purpose)
	m_size_buttons_x = m_defparam_size_button_x * 2 + m_defparam_space_between_buttons_x;
	m_size_buttons_half_x = m_size_buttons_x / 2;

// == only controls size (without buttons and indents) ==
//	m_size = size;
	m_size.x = w;
	m_size.y = h;
//	m_size_x = size.x;
//	m_size_y = size.y;
	m_size_half_x = m_size.x / 2;
	m_size_half_y = m_size.y / 2;

// == whole panel size ==
	m_size_panel = m_size;
	if (m_size_panel.x < m_size_buttons_x)
		m_size_panel.x = m_size_buttons_x;
//	m_size_panel_half_x = m_size_panel.x / 2;
//	m_x_middle = m_size_dialog_half_x;
//	m_x_middle = m_size_panel_half_x;
	m_x_middle = m_size_panel.x / 2;
	m_y_middle = m_size_panel.y / 2;
//	m_y_middle += SIZE_CAPTION + SIZE_BORDER;
	m_size_panel.y += m_defparam_indent_buttons_above;
	m_size_panel.y += m_defparam_size_button_y;
	m_size_panel.y += m_defparam_indent_buttons_below;
//	m_size_panel.x += m_defparam_indent_x * 2;
//	m_size_panel.y += m_defparam_indent_y * 2;
	m_y_middle_panel = m_size_panel.y / 2;

// == dialog size ==
//	m_indent_buttons_x = m_defparam_indent_x;
	m_size_dialog = m_size_panel;
	m_size_dialog.x += m_defparam_indent_x * 2;
	m_size_dialog.y += m_defparam_indent_y * 2;
	m_size_dialog.x += SIZE_BORDER * 2;
	m_size_dialog.y += SIZE_CAPTION;
	m_size_dialog.y += SIZE_BORDER * 2;
//	m_size_dialog_half_x = m_size_dialog.x / 2;

	m_x_begin = m_x_middle - m_size_half_x;
	m_x_end = m_x_middle + m_size_half_x;
//	m_y_begin = SIZE_BORDER;
//	m_y_begin += SIZE_CAPTION;
	m_y_begin = 0;
//	m_y_begin += m_defparam_indent_y;
	m_y_end = m_y_begin + m_size.y;

	m_buttons_x_begin = m_x_middle - m_size_buttons_half_x;
	m_buttons_y = m_y_end + m_defparam_indent_buttons_above;

// one or both must be zero
	wxASSERT(! m_x_begin || ! m_buttons_x_begin);

// dislike I that question mark :) (it isn't good helpful)
//	SetExtraStyle (wxDIALOG_EX_CONTEXTHELP);

// set proper size now
	SetSize (m_size_dialog);

// border and caption of dialog box indents automatically
//	m_panel = new wxPanel (this, wxID_ANY, wxDefaultPosition, m_size_panel,
	m_panel = new wxPanel (this, wxID_ANY, wxPoint (m_defparam_indent_x, m_defparam_indent_y), m_size_panel,
//		wxTAB_TRAVERSAL | wxWANTS_CHARS);
		wxWANTS_CHARS);
}

void DialogWithButtons::AppendMainButtons ()
{
//	int size_half_x;
//	size_half_x = m_size_buttons_x / 2;
	int pos_x;
	int pos_y;

	pos_x = m_buttons_x_begin;
	pos_y = m_buttons_y;
	new wxButton (m_panel, wxID_OK, _T("Ok"), wxPoint (pos_x, pos_y),
		wxSize (m_defparam_size_button_x, m_defparam_size_button_y));
	pos_x += m_defparam_size_button_x + m_defparam_space_between_buttons_x;
	new wxButton (m_panel, wxID_CANCEL, _T("Cancel"), wxPoint (pos_x, pos_y),
		wxSize (m_defparam_size_button_x, m_defparam_size_button_y));
}

// use it anyway, the 'm_x_begin' will not be zero when the controls' size is small
// must be 'ControlPosOnPanel ()' theoretically, but would be long name
wxPoint DialogWithButtons::PosOnPanel (int x, int y)
{
	wxPoint size;

	size.x = m_x_begin + x;
	size.y = m_y_begin + y;
	return size;
}
#endif

// child must request this, instead of 'SetSizer ()'
void DialogWithButtons::SetSizerAndButtons (int sizer_contain_border)
{
	wxButton* button;
	bool was_button_added = 0;

	m_buttons_flags;
// *'wxDialogBase::CreateStdDialogButtonSizer ()' does not adds any space between buttons; must add manually buttons and spaces
	if (m_buttons_flags & wxOK)
	{
		button = new wxButton (this, wxID_OK, _T("Ok"), wxDefaultPosition,
			wxSize (m_defparam_size_button_x, m_defparam_size_button_y));
		was_button_added = 1;
		m_sizer_buttons->Add (button);
	}
// this adds both, width and height
//	m_sizer_buttons->AddSpacer (m_defparam_space_between_buttons_x);
	if (was_button_added)
	{
		m_sizer_buttons->Add (m_defparam_space_between_buttons_x, 0);
		was_button_added = 0;
	}
	if (m_buttons_flags & wxCANCEL)
	{
		button = new wxButton (this, wxID_CANCEL, _T("Cancel"), wxDefaultPosition,
			wxSize (m_defparam_size_button_x, m_defparam_size_button_y));
		m_sizer_buttons->Add (button);
	}

// if nothing add to this sizer, then the size would be the same as without adding of this sizer
	m_sizer_dialog->Add (m_sizer_contain, 0, wxALL | wxALIGN_CENTRE_HORIZONTAL, sizer_contain_border);
// buttons are too close to controls
//	m_sizer_dialog->AddSpacer (20);
	m_sizer_dialog->Add (m_sizer_buttons, 0, wxALL | wxALIGN_CENTRE_HORIZONTAL, 13);
	SetSizer (m_sizer_dialog);
// resize dialog window; *parent must be frame window
	m_sizer_dialog->SetSizeHints (this);
}

// by "widgets" sample
// *originally was returning wxSizer
bool DialogWithButtons::CreateSizerWithControlAndLabel_Vertically (wxBoxSizer** new_sizer, wxControl* ctrl, const wxString& label, int border_orient, int border, wxWindowID text_ctrl_id)
{
	wxBoxSizer* sizer_box;
	wxStaticText* static_text;
//	wxTextCtrl* ctrl_text;
//	int border = 10;

	Assert(new_sizer);
	Assert(ctrl);
	sizer_box = new wxBoxSizer (wxVERTICAL);
	if (! sizer_box)
		return 0;
	static_text = new wxStaticText (this, wxID_ANY, label);
	if (! static_text)
	{
		delete sizer_box;
		return 0;
	}
// give small border
	sizer_box->Add (static_text, 0, (border_orient & ~wxBOTTOM) | wxALIGN_CENTRE_HORIZONTAL, border);
// too close; readability drops
	sizer_box->AddSpacer (4);
	sizer_box->Add (ctrl, 0, (border_orient & ~wxTOP) | wxALIGN_CENTRE_HORIZONTAL, border);
	*new_sizer = sizer_box;
	return 1;
}

// when creating a table of ctrls with descriptions, this method have more sense than to create two sizers, and synchronously fill them.
// currently, a ctrl input is aligned with other ctrl inputs by this way :  the input ctrl is right-aligned and have the same size.
// *does not supports default size; the control must have defined size.
bool DialogWithButtons::CreateSizerWithControlAndLabel_Horizontally (wxBoxSizer** new_sizer, wxControl* ctrl, const wxString& label, int border_orient, int border, wxWindowID text_ctrl_id)
{
	wxBoxSizer* sizer_box;
	wxStaticText* static_text;
	int lower_statictext;
	wxSize size;

	Assert(new_sizer);
	Assert(ctrl);
	sizer_box = new wxBoxSizer (wxHORIZONTAL);
	if (! sizer_box)
		return 0;
	static_text = new wxStaticText (this, wxID_ANY, label);
	if (! static_text)
	{
		delete sizer_box;
		return 0;
	}

#define RISE_CTRL_SIZE 1
// my font needs to be lowered
// on (8 - 7) 1 line, when aligned by bottom
// on (8 - 5) 3 lines, when aligned by center
//	size = ctrl->GetSize ();
	size = ctrl->GetMinSize ();
// aligned with controls' text
#if RISE_CTRL_SIZE
// rise the size of the static text, so it would be lower a few
	lower_statictext = 3;
	size.y += lower_statictext * 2;
#else
// for correcting the static text, the ctrl size is rised, instead of changing static text size; it is the simpliest way
//// *the code below uses align to bottom instead of center
//	lower_statictext = control_height / 4;
// 1 point lower, than controls' text
//	lower_statictext += control_height / 16;
//	lower_statictext = size.y * 5;
//	lower_statictext /= 16;
	lower_statictext = size.y / 2;
	lower_statictext -= 7;
	if (lower_statictext < 0)
		lower_statictext = 0;
	size.y += lower_statictext;
#endif
//	ctrl->SetSize (size);
	ctrl->SetMinSize (size);

// give small border
// allow growth, so the text would match the other, which are below and above
// 'proportion' will be for horizontal stretch; 'wxEXPAND' will be for vertical stretch
	sizer_box->Add (static_text, 1, (border_orient & ~wxRIGHT) | wxALIGN_CENTRE_VERTICAL, border);
//	sizer_box->Add (static_text, 1, (border_orient & ~wxRIGHT) | wxEXPAND | wxALIGN_CENTRE_VERTICAL, border);
//	sizer_box->Add (static_text, 1, (border_orient & ~wxRIGHT) | wxSHAPED | wxALIGN_CENTRE_VERTICAL, border);
// little bit not enough, and needs additional correction, which is made above
//	sizer_box->Add (static_text, 0, (border_orient & ~wxRIGHT) | wxALIGN_BOTTOM, border);
	sizer_box->AddSpacer (4);
	sizer_box->Add (ctrl, 0, (border_orient & ~wxLEFT) | wxALIGN_CENTRE_VERTICAL, border);
// test
//	sizer_box->Add (ctrl, 0, (border_orient & ~wxLEFT) | wxALIGN_TOP, border);
	*new_sizer = sizer_box;
	return 1;
}

bool DialogWithButtons::CreateSizerWithTextAndLabel_Vertically (wxBoxSizer** new_sizer, wxTextCtrl** text_ctrl, const wxString& label, int border_orient, int border, wxWindowID text_ctrl_id)
{
	bool result;
	wxTextCtrl* ctrl_text;
//	int border = 10;

	Assert(new_sizer);
// 'wxEmptyString' instead of an inital value - prevents of 'OnText()' request !
	ctrl_text = new wxTextCtrl (this, text_ctrl_id, wxEmptyString, wxDefaultPosition, m_defparam_ctrl_size_textctrl, wxTE_PROCESS_ENTER);
	if (! ctrl_text)
		return 0;
	result = CreateSizerWithControlAndLabel_Vertically (new_sizer, ctrl_text, label, border_orient, border, text_ctrl_id);
	if (! result)
	{
		delete ctrl_text;
		return 0;
	}
	if (text_ctrl)
		*text_ctrl = ctrl_text;
	return 1;
}

bool DialogWithButtons::CreateSizerWithTextAndLabel_Horizontally (wxBoxSizer** new_sizer, wxTextCtrl** text_ctrl, const wxString& label, int style, int border_orient, int border, wxWindowID text_ctrl_id)
{
	bool result;
	wxTextCtrl* ctrl_text;

	Assert(new_sizer);
// 'wxEmptyString' instead of an inital value - prevents of 'OnText()' request !
	ctrl_text = new wxTextCtrl (this, text_ctrl_id, wxEmptyString, wxDefaultPosition, m_defparam_ctrl_size_textctrl, wxTE_PROCESS_ENTER | style);
	if (! ctrl_text)
		return 0;
	result = CreateSizerWithControlAndLabel_Horizontally (new_sizer, ctrl_text, label, border_orient, border, text_ctrl_id);
	if (! result)
	{
		delete ctrl_text;
		return 0;
	}
	if (text_ctrl)
		*text_ctrl = ctrl_text;
	return 1;
}

// *'wxTextCtrl' have own 'SetBackgroundColour ()', but there I don't see anything serious
void DialogWithButtons::SetBackgroundValidnessColour (wxWindow* ctrl, bool is_valid)
{
	if (is_valid)
		ctrl->SetBackgroundColour (m_colour_background);
	else
		ctrl->SetBackgroundColour (m_colour_wrong_value);
	ctrl->Refresh ();
}

void DialogWithButtons::SetBackgroundColour_Passive (wxWindow* ctrl)
{
	ctrl->SetBackgroundColour (m_colour_passive);
//	ctrl->Refresh ();
}

bool DialogWithButtons::CtrlReadUInt (wxTextCtrl* ctrl, uint* val)
{
	bool result;
	wxString wxstr;
	stringstream strm;

	Assert(ctrl);
	Assert(val);
	wxstr = ctrl->GetValue ();
	strm << wxstr.c_str ();
// *will always be eof
	strm >> *val;
//	result = strm.good ();
	result = strm.fail ();
// zero values are invalid here
	if (! result)
		if (! *val)
			return 0;

	return ! result;
}

bool DialogWithButtons::CtrlReadDouble (wxTextCtrl* ctrl, double* val, bool zero_allowed)
{
	bool result;
	wxString wxstr;
	stringstream strm;
//	string str;

	wxstr = ctrl->GetValue ();
	strm << wxstr.c_str ();
	strm >> *val;
//	strm >> str;
	result = ! strm.fail ();
// no eof, if dot appears once again, and no fail also; so check eof
	result &= strm.eof ();
	if (! zero_allowed)
// zero values are invalid here
		if (result)
			if (*val == 0.0)
				return 0;

	return result;
}

bool DialogWithButtons::CtrlReadULong (wxTextCtrl* ctrl, ulong* val)
{
	bool result;
	wxString wxstr;
	stringstream strm;

	Assert(ctrl);
	Assert(val);
	wxstr = ctrl->GetValue ();
	strm << wxstr.c_str ();
// *will always be eof
	strm >> *val;
//	result = strm.good ();
	result = strm.fail ();
// zero values are invalid here
	if (! result)
		if (! *val)
			return 0;

	return ! result;
}

bool DialogWithButtons::CtrlReadUInt64 (wxTextCtrl* ctrl, uint64* val)
{
	wxString wxstr;

	Assert(ctrl);
	Assert(val);
	wxstr = ctrl->GetValue ();

// hmmm, int64 unsupported for stringstream; at least by MSVC 6.0
#if 0
	bool result;
	stringstream strm;

	strm << wxstr.c_str ();
// *will always be eof
	strm >> *val;
	strm >> *(int64*)val;
//	result = strm.good ();
	result = strm.fail ();

	return ! result;
#else
// make simple converter then, if don't have from C++
	const uint64 value_max = ((uint64)-1) / 10;
	uint64 i = 0;
	char c;
	const char* ptr;

	ptr = wxstr.c_str();
	if (! *ptr)
		return 0;
//loop:
	while (c = *ptr)
	{
		c -= '0';
		if (c < 0)
			return 0;
		if (c >= 10)
			return 0;
		if (i > value_max)
			return 0;
		i *= 10;
		i += c;
		ptr++;
	}
//	goto loop;
	*val = i;
	return 1;
#endif
}

