#pragma once

#include "wx/dialog.h"
//#include "wx/panel.h"
#include "wx/sizer.h"
#include "wx/textctrl.h"
#include "wx_colour_m.h"


// *much easier is to force own buttons sizes, instead of trying to get them somehow from Widgets and then do calculations
#define DIALOG_WITH_BUTTONS__SIZE__BUTTON_X 100
// looks like 24 is Windows default
#define DIALOG_WITH_BUTTONS__SIZE__BUTTON_Y 24
#define DIALOG_WITH_BUTTONS__DEFAULT_BORDER 10


class DialogWithButtons : public wxDialog
{
public:
// tend at - long names for the whole dialog sizes (private memebers),
// and short for the controls' panel part (available/protected members)

// this of course must be not here; but will be no better place where to put it
	wxColourM m_colour_background;
	wxColourM m_colour_wrong_value;
	wxColourM m_colour_passive;

protected:
// size cannot be default and is the size on the panel for an added controls
	DialogWithButtons (wxWindow* window_parent, const wxString& title, int sizer_orient,
//		long style = wxDEFAULT_DIALOG_STYLE, const wxString& name = "Dialog box with buttons");
		const wxString& name = "Dialog box with buttons", long buttons_flags = wxOK | wxCANCEL, long style = wxDEFAULT_DIALOG_STYLE);
//	void DefineAndSetSizes (int w, int h);
// Ok/Cancel buttons must be placed last, after all other controls
//	void AppendMainButtons ();
//	wxPoint PosOnPanel (int x, int y);
	void SetSizerAndButtons (int sizer_contain_border = 0);
	bool CreateSizerWithControlAndLabel_Vertically (wxBoxSizer** new_sizer, wxControl* ctrl, const wxString& label,
		int border_orient = wxALL, int border = DIALOG_WITH_BUTTONS__DEFAULT_BORDER, wxWindowID text_ctrl_id = wxID_ANY);
	bool CreateSizerWithControlAndLabel_Horizontally (wxBoxSizer** new_sizer, wxControl* ctrl, const wxString& label,
		int border_orient = wxALL, int border = 0, wxWindowID text_ctrl_id = wxID_ANY);
	bool CreateSizerWithTextAndLabel_Vertically (wxBoxSizer** new_sizer, wxTextCtrl** text_ctrl, const wxString& label,
		int border_orient = wxALL, int border = DIALOG_WITH_BUTTONS__DEFAULT_BORDER, wxWindowID text_ctrl_id = wxID_ANY);
	bool CreateSizerWithTextAndLabel_Horizontally (wxBoxSizer** new_sizer, wxTextCtrl** text_ctrl, const wxString& label,
		int style = 0, int border_orient = wxALL, int border = DIALOG_WITH_BUTTONS__DEFAULT_BORDER, wxWindowID text_ctrl_id = wxID_ANY);
	void SetBackgroundValidnessColour (wxWindow* ctrl, bool is_valid);
	void SetBackgroundColour_Passive (wxWindow* ctrl);
	bool CtrlReadUInt (wxTextCtrl* ctrl, uint* val);
	bool CtrlReadDouble (wxTextCtrl* ctrl, double* val, bool zero_allowed);
	bool CtrlReadULong (wxTextCtrl* ctrl, ulong* val);
	bool CtrlReadUInt64 (wxTextCtrl* ctrl, uint64* val);

//	wxPanel* m_panel;
	wxBoxSizer* m_sizer_contain;

// these are initialized in the constructor, and may be modified later, but before 'DefineAndSetSizes ()'
	int m_defparam_size_button_x;
	int m_defparam_size_button_y;
	int m_defparam_space_between_buttons_x;
//	int m_defparam_indent_x;
//	int m_defparam_indent_y;
//	int m_defparam_indent_buttons_above;
//	int m_defparam_indent_buttons_below;
	wxSize m_defparam_ctrl_size_textctrl;

// size for controls (without ok/cancel buttons)
	wxSize m_size;
//	int m_size_x;
//	int m_size_y;
	int m_size_half_x;
	int m_size_half_y;
// + offsets +
	int m_x_begin;
	int m_y_begin;
	int m_x_end;
	int m_y_end;
	int m_x_middle;
	int m_y_middle;
	int m_y_middle_panel;
// - offsets -

private:
	long m_buttons_flags;
//	wxSize m_size_to_add;
//	wxSize m_size_panel;
//	wxSize m_size_dialog;
	int m_size_buttons_x;
	int m_size_buttons_half_x;
//	int m_size_panel_half_x;
//	int m_size_dialog_half_x;
//	int m_indent_x;
//	int m_indent_y;
//	int m_indent_buttons_x;
//	int m_indent_buttons_y;
	int m_buttons_x_begin;
	int m_buttons_y;
	wxBoxSizer* m_sizer_dialog;
	wxBoxSizer* m_sizer_buttons;
//	wxSizer* m_sizer_buttons;

//	DECLARE_EVENT_TABLE()
};

