#pragma once

#include "project.h"
#include "wx/grid.h"
//#include "fix.h"
#include "wx/config.h"


// in Widgets samples it is called "canvas"
class Display : public wxScrolledWindow
{
public:
//	Display (Project* project)
//	Display (wxFrame* frame, Project* project);
	Display (wxWindow* parent, Project* project);
	void Config_Read (wxConfigBase* config);
	void Config_Write (wxConfigBase* config);

	void Autosize ();
	void DefineSize ();

	Project* m_proj;
// +++ settings +++
// must be even
	int m_wave_height;
	int m_wave_height_half;
	int m_indent_x;
	int m_indent_y;
// ohoh, I am going wrong :)
//	int m_space_x;
// space is excluding the indent
	int m_space_y;
	int m_view_wave_blend_mode;
// --- settings ---
// both with indents and spaces
	int m_width;
	int m_height;
// parallel to 'm_wave_height'
	uint m_wave_width_max;
	fix64 m_time_per_pixel;
//	fix64 m_cursor_time_pos;
	uint m_cursor_pos_x;

private:
//	int GetWaveOffsetY (int ix, bool without_last_space);
//	int GetWaveOffsetY (int ix, bool after_indent);
	int GetWaveOffsetY (int ix);
	int GetWaveIxByOffsetY (int pos_y);
// creates value by necessary 'm_time_per_pixel'
//	int GetFullWidth ();
	fix64 GetTimeLengthMax ();
	int GetFullHeight ();
	int CalculateLevelPointOffset (wave_data_t level);
//	void PaintWave_ConnectedDots (wxPaintDC* dc, wxRect& update_rect, Wave* wave, int pos_x, int pos_y);
	void PaintWave_ConnectedDots (wxPaintDC* dc, uint beg_x, uint end_x, Wave* wave, int pos_x, int pos_y);
//	void PaintWave_Blended (wxPaintDC* dc, wxRect& update_rect, Wave* wave, int pos_x, int pos_y);
	void PaintWave_Blended (wxPaintDC* dc, uint beg_x, uint end_x, Wave* wave, int pos_x, int pos_y);
	uint GetWindowBegin (wxDC* dc);
	void PaintWave (wxPaintDC* dc, wxRect& update_rect, uint wave_ix);
//	void CursorDraw (wxPaintDC* dc, bool on);
	void CursorDraw (wxPaintDC* dc, uint pos_y, uint height);
//	void CursorClear (wxPaintDC* dc);
	void CursorClear (wxDC* dc);
	void CursorMove_LeftRight (bool forward);
	void CursorMove_HomeEnd (bool forward);
	fix64 LogicalXToTime (uint x);
//	uint LogicalYToWave (uint y);
	bool TimeToSample (uint64& sample_ix, uint wave_ix, fix64 time);
//	bool XToSample (uint& sample_ix, uint x);
	void GetMouseLogicalPosition (wxMouseEvent& event, uint* x = 0, uint* y = 0);
//	void GetMouseLogicalPosition (wxMouseEvent& event, uint* x = 0, uint* y = 0, uint* width = 0, uint* height = 0);
	void ChangeTimeResolution (bool more_detailed, double coefficient);
	void CursorBound ();
	void CursorSetByTime (fix64 time_pos);
	void UpdatePos (double indent);
//	void FictivlySetCursor (uint pos_x);
	void FictivlySetCursor ();

// +++ events +++
//public:
	void OnPaint (wxPaintEvent& event);
	void OnLeftDown (wxMouseEvent& event);
	void OnMotion (wxMouseEvent& event);
	void OnLeaveWindow (wxMouseEvent& event);
public:
	void OnChar (wxKeyEvent& event);
// --- events ---

private:
	wxWindow* m_window_parent;

	wxColourDatabase db_colours;
//	wxGrid* m_grid;
// + common colours +
	wxColour m_colour_background;
	wxColour m_colour_space;
	wxColour m_colour_wave_main_pen;
	wxColour m_colour_wave_indent;
	wxColour m_colour_wave_indent_selected;
	wxColour m_colour_wave_middle_line;
// - common colours -
// + density view +
	wxColour m_colour_wave_background;
// - density view -
// + detailed view +
	wxColour m_colour_wave_background_detailed;
	wxColour m_colour_wave_connection_lines;
	wxColour m_colour_wave_dots_detailed;
// - detailed view -
	wxColour m_colour_cursor;

	DECLARE_EVENT_TABLE()
	DECLARE_NO_COPY_CLASS(Display);
};

