// unloaded some part of FileTreeCtrl here

#include "file_properties.h"
#include "dialog_file_waves.h"
#include "dialog_samples.h"
#include "console.h"
#include "ids.h"
#include "events.h"


FileProperties::FileProperties (File* file, Project* project, wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style, const wxValidator& validator, const wxString& name)
:
wxGenericTreeCtrl (parent, id, pos, size, style, validator, name)
{
	m_proj = project;
	m_file = file;
}

void FileProperties::SendUpdateEvent ()
{
//	wxNotifyEvent event (FRAME__UPDATE_DISPLAY, GetId());
	wxNotifyEvent event (wxEVT__FRAME__UPDATE_DISPLAY, GetId());
	event.SetEventObject (this);
	GetEventHandler ()->ProcessEvent (event);
}

void FileProperties::Waves_Manage ()
{
	DialogFileAddRemoveWaves* dialog_file_waves;

	dialog_file_waves = new DialogFileAddRemoveWaves (this, m_file, m_proj);
	delete dialog_file_waves;
	Reinit ();
// 'delete' should not be used, but 'Destroy ()' instead; but hmmm, maybe not when wxID_OK (?)
// strange that :/ ; must it be requested here ? :/
// strange, how it can be without 'delete' :/
//	dialog_file_waves->Destroy ();
}

void FileProperties::Waves_Delete ()
{
	Waves_GetSelections ();
	m_file->Waves_Selected_Delete ();
	Reinit ();
}

void FileProperties::Waves_Samples_InsertRemove (bool is_insert)
{
	bool result;
	uint64 common_samples_num;
	DialogSamples* dialog_samples;
	bool have_common_samples_num;
	set_int::iterator i;
	TCHAR* dialog_name;

	Waves_GetSelections ();
	if (! m_file->m_selections.size())
	{
		Console_ProgramError ("FileProperties::Waves_Samples_InsertRemove () :  no waves selected");
		return;
	}
	have_common_samples_num = m_file->Waves_Selected_GetCommonSamplesNum (common_samples_num);
	if (is_insert)
		dialog_name = "Insert samples";
	else
		dialog_name = "Remove samples";
	dialog_samples = new DialogSamples (this, dialog_name, is_insert);
	result = dialog_samples->Invoke (have_common_samples_num, common_samples_num);
	if (! result)
		goto delete_dialog;
	for (i = m_file->m_selections.begin(); i != m_file->m_selections.end(); i++)
	{
		Wave* wave;
		wave = m_file->m_containing_waves[*i];
		if (is_insert)
			wave->Samples_Insert (dialog_samples->m_offset, dialog_samples->m_samples_num);
		else
			wave->Samples_Remove (dialog_samples->m_offset, dialog_samples->m_samples_num);
	}
	if (dialog_samples->m_update_file)
		m_file->UpdateParameters ();

	SendUpdateEvent ();

delete_dialog:
	delete dialog_samples;
	Reinit ();
}

