//
// *contains code from "generic/treectrlg.cpp".
// part of the code is moved to "file_properties.cpp", to unload a bit.

#include "file_tree_ctrl.h"
#include "console.h"
#include "ids.h"
#include "wx/menu.h"
#include "wx/dcclient.h"
#include "dialog_file_properties.h"
#include "error.h"
//#include "dialog_samples.h"
#include "events.h"


BEGIN_EVENT_TABLE(FileTreeCtrl, wxGenericTreeCtrl)
// generated for every item when 'DeleteAllItems ()'
//	EVT_TREE_DELETE_ITEM
	EVT_TREE_ITEM_COLLAPSING(wxID_ANY, OnCollapsing)
//	EVT_TREE_ITEM_RIGHT_CLICK(TreeTest_Ctrl, FileTreeCtrl::OnItemRClick)
//	EVT_TREE_ITEM_RIGHT_CLICK(FileTreeCtrl::m_id, FileTreeCtrl::OnItemRClick)
// 'EVT_RIGHT_DOWN()' requests (registers) with 'wxID_ANY'
//	EVT_TREE_ITEM_RIGHT_CLICK(wxID_ANY, FileTreeCtrl::OnItemRClick)
	EVT_TREE_ITEM_MENU(wxID_ANY, FileTreeCtrl::OnItemMenu)
	EVT_TREE_SEL_CHANGING(wxID_ANY, FileTreeCtrl::OnSelChanging)
	EVT_LEFT_DOWN(FileTreeCtrl::OnLMouseDown)
//	EVT_RIGHT_DOWN(FileTreeCtrl::OnRMouseDown)
// it appears after something has been chosen (or not) from the popup menu
//	EVT_CONTEXT_MENU(FileTreeCtrl::OnItemMenu)
	EVT_MENU(FILE_TREE_CTRL__ID_MANAGE_WAVES, FileTreeCtrl::OnManageWaves)
	EVT_MENU(FILE_TREE_CTRL__ID_FILE_PROPERTIES, FileTreeCtrl::OnFileProperties)
	EVT_MENU(FILE_TREE_CTRL__ID_DELETE_WAVE, FileTreeCtrl::OnDeleteWaves)
	EVT_MENU(FILE_TREE_CTRL__ID_SAMPLES_INSERT, FileTreeCtrl::OnSamplesInsert)
	EVT_MENU(FILE_TREE_CTRL__ID_SAMPLES_REMOVE, FileTreeCtrl::OnSamplesRemove)
	EVT_CHAR(FileTreeCtrl::OnChar)
END_EVENT_TABLE()

enum
{
	FILE_TREE_CTRL_ITEM_TYPE__NONE,
	FILE_TREE_CTRL_ITEM_TYPE__FILE,
	FILE_TREE_CTRL_ITEM_TYPE__WAVE,
	FILE_TREE_CTRL_ITEM_TYPES_NUM
};

class FileTreeCtrlItemData : public wxTreeItemData
{
public:
	FileTreeCtrlItemData (int type, int ix)
	{
		m_type = type;
		m_ix = ix;
	}
	int m_type;
	int m_ix;
};


FileTreeCtrl::FileTreeCtrl (File* file, Project* project, wxWindow* parent, wxWindowID id, const wxPoint& pos, const wxSize& size, long style, const wxValidator& validator, const wxString& name)
:
//wxGenericTreeCtrl (parent, id, pos, size, style, validator, name),
//wxGenericTreeCtrl (parent, id, pos, size, style | wxCAPTION, validator, name),
//FileProperties (file)
FileProperties (file, project, parent, id, pos, size, style, validator, name)
{
//	m_id = id;
// for access from such as this class, but from outside
// (currently is only necessary for unselect other files)
//	m_file->m_file_tree_ctrl = this;
	Init ();
}

// create items and their data
void FileTreeCtrl::Init ()
{
	int ix;
	int i;
	int waves_num;
	wxTreeItemId id_root;
	wxString str;
	FileTreeCtrlItemData* item_data;

	waves_num = m_file->m_containing_waves_num;
	ix = m_file->m_ix;
	str.Printf ("File %d", ix);
	item_data = new FileTreeCtrlItemData (FILE_TREE_CTRL_ITEM_TYPE__FILE, ix);
//	id_root = AddRoot (str);
	id_root = AddRoot (str, -1, -1, item_data);
	for (i = 0; i < waves_num; i++)
	{
		Wave* wave;
		wave = m_file->m_containing_waves[i];
		ix = wave->m_ix;
//		str.Printf ("%02d Wave %02d", i, ix);
		str.Printf ("%d Wave %d", i, ix);
//		item_data = new FileTreeCtrlItemData (FILE_TREE_CTRL_ITEM_TYPE__WAVE, ix);
		item_data = new FileTreeCtrlItemData (FILE_TREE_CTRL_ITEM_TYPE__WAVE, i);
//		AppendItem (id_root, str);
		AppendItem (id_root, str, -1, -1, item_data);
	}
	Expand (id_root);
}

void FileTreeCtrl::Reinit ()
{
	DeleteAllItems ();
	Init ();
//	Refresh ();
}

void FileTreeCtrl::CalculateSizes (wxSize& size)
{
//	wxDC dc (this);
	wxClientDC dc (this);
//	wxPaintDC dc (this);
	int y;

//	size.x = 0;
// x size isn't available (lets hope - yet)
	size.x = MY_TREE_CTRL_WIDTH;
	size.y = 0;
// + just copied from "generic/treectrlg.cpp" +
	y = 2;
	PrepareDC (dc);
	if (! m_anchor)
		return;
	dc.SetFont (m_normalFont);
	dc.SetPen (m_dottedPen);
// - just copied from "generic/treectrlg.cpp" -
// invalidate
	Refresh ();
// + just copied from "generic/treectrlg.cpp" +
	PaintLevel (m_anchor, dc, 0, y);
// - just copied from "generic/treectrlg.cpp" -
// wrong
//	size.x = dc.MaxX () - dc.MinX ();
// wrong
//	size.y = dc.MaxY () - dc.MinY ();
// probably is +2
	size.y = y + 2;
}

#if 0
// +++++ Do___ +++++

// no sense :)
void FileTreeCtrl::DoSelectItem (const wxTreeItemId& item_id, bool unselect_others, bool extended_select)
{
	wxTreeItemId item_id1;
	FileTreeCtrlItemData* item_data;
	wxArrayTreeItemIds selection;
	uint selected_num;
	int already_selected_type;

	if (unselect_others)
		goto finish;
// 'wxTR_MULTIPLE'
	selected_num = GetSelections (selection);
// not happens
	if (! selected_num)
		goto finish;
	item_id1 = selection[0];
	if (! item_id1.IsOk ())
		goto finish;
	item_data = (FileTreeCtrlItemData*)GetItemData (item_id1);
	already_selected_type = item_data->m_type;

	item_data = (FileTreeCtrlItemData*)GetItemData (item_id);
	if (item_data->m_type != already_selected_type)
		return;

finish:
	wxGenericTreeCtrl::DoSelectItem (item_id, unselect_others, extended_select);
}

// ----- Do___ -----
#endif

void FileTreeCtrl::ShowMenuFile (wxTreeItemId id, const wxPoint& pt)
{
	wxString title;

	wxASSERT (id.IsOk ());
	title = wxT("Menu for file");
	wxMenu menu (title);
	menu.Append (FILE_TREE_CTRL__ID_MANAGE_WAVES, wxT("Manage wave(s) (ins)"));
	menu.Append (FILE_TREE_CTRL__ID_FILE_PROPERTIES, wxT("Properties"));
//	menu.AppendSeparator ();
	PopupMenu (&menu, pt);
}

void FileTreeCtrl::ShowMenuWave (wxTreeItemId id, const wxPoint& pt)
{
	wxString title;

	wxASSERT (id.IsOk ());
	title = wxT("Menu for wave");
	wxMenu menu (title);
	menu.Append (FILE_TREE_CTRL__ID_DELETE_WAVE, wxT("Remove wave(s) (del)"));
	menu.Append (FILE_TREE_CTRL__ID_SAMPLES_INSERT, wxT("Samples insert"));
	menu.Append (FILE_TREE_CTRL__ID_SAMPLES_REMOVE, wxT("Samples remove"));
//	menu.AppendSeparator ();
	PopupMenu (&menu, pt);
}

//// uhoh, I lost the sense - by this way is not possible
//// I will use it, but for a bit other purposes
//void FileTreeCtrl::Waves_Iterate_Selected (void* func (int wave_ix))
// copy selections to own array, which will be sorted, and with which will be possible to use an iterators
void FileTreeCtrl::Waves_GetSelections ()
{
	int wave_ix;
	int selected_num;
	wxTreeItemId item_id;
	FileTreeCtrlItemData* item_data;
	wxArrayTreeItemIds selection;
	int i;

//	m_selections.clear ();
	m_file->m_selections.clear ();
// 'wxTR_MULTIPLE'
	selected_num = GetSelections (selection);
	for (i = selected_num - 1; i >= 0; i--)
	{
		item_id = selection[i];
		wxASSERT(item_id.IsOk ());
		item_data = (FileTreeCtrlItemData*)GetItemData (item_id);
		wxASSERT(item_data->m_type == FILE_TREE_CTRL_ITEM_TYPE__WAVE);
		wave_ix = item_data->m_ix;
//		func (wave_ix);
//		m_selections.insert(wave_ix);
		m_file->m_selections.insert(wave_ix);
	}
}

//void FileTreeCtrl::SelectionSet (bool selected)
void FileTreeCtrl::SelectionSet ()
{
//	wxColour clr;
//	wxColour* clr;
	wxColourM clr;
//	wxColour clr_diff;

// discoloured grey
//	clr = wxNullColour;
// this is desktop colour
//	clr = wxSystemSettings::GetColour (wxSYS_COLOUR_BACKGROUND);
// window background; white
	clr = wxSystemSettings::GetColour (wxSYS_COLOUR_WINDOW);
	if (m_file->m_is_selected)
	{
//		clr_diff = ;
		clr.Add (-20, -10, 0);
	}
	SetBackgroundColour (clr);
}

#if 0
// hmmm, shouldn't this be a level higher :/
void FileTreeCtrl::SelectionClearAll ()
{
	int i;

	for (i = 0; i < m_proj->m_files_num; i++)
	{
		File* file;
		FileTreeCtrl* file_tree_ctrl;
		file = m_proj->m_files[i];
		file_tree_ctrl = (FileTreeCtrl*)file->m_file_tree_ctrl;
		Assert(!! file_tree_ctrl);
		file->m_is_selected = 0;
		file_tree_ctrl->SelectionSet ();
	}
}
#endif

void FileTreeCtrl::SendFileSelectionsResetEvent ()
{
#if 0
	wxNotifyEvent event (WINDOW_FILES__RESET_FILE_SELECTIONS, GetId());
#else
//	wxNotifyEvent event (FRAME__DISPATCH_SIMPLE_EVENT_TO__WINDOW_FILES, GetId());
	wxNotifyEvent event (wxEVT__FRAME__DISPATCH_SIMPLE_EVENT_TO__WINDOW_FILES, GetId());
// *'SetInt()' maybe more properly ?
//	event.SetClientData ((void*)WINDOW_FILES__RESET_FILE_SELECTIONS);
// test
//	event.SetInt (wxEVT_COMMAND_BUTTON_CLICKED);
//	event.SetInt (wxEVT__DUMMY0);
	event.SetInt (wxEVT__WINDOW_FILES__RESET_FILE_SELECTIONS);
#endif
	event.SetEventObject (this);
	GetEventHandler ()->ProcessEvent (event);
	SendUpdateEvent ();
}

// +++++ event handlers +++++

void FileTreeCtrl::OnCollapsing (wxTreeEvent& event)
{
// prevent :P
	event.Veto ();
}

// do not use current (the event) item at all, if it is unselect, very possible that user have pressed it occasionally
// a) if nothing selected - no need to select current item, it is mouse event, which is secondary controller
// (it not happens; it selects event item automatically)
// b) if some item(s) already is selected - really wrong would be to select current item (alone or also)
//void FileTreeCtrl::OnItemRClick (wxTreeEvent& event)
void FileTreeCtrl::OnItemMenu (wxTreeEvent& event)
{
	wxTreeItemId item_id;
	FileTreeCtrlItemData* item_data;
	wxPoint client_pt;
	wxArrayTreeItemIds selection;
	uint selected_num;

// the item, on which the right mouse button has been pressed, even if it isn't selected
//	item_id = event.GetItem ();
// 'wxTR_MULTIPLE'
	selected_num = GetSelections (selection);
// not happens
	if (! selected_num)
		goto finish;
// other items will be of the same type
	item_id = selection[0];
	if (! item_id.IsOk ())
		goto finish;
	item_data = (FileTreeCtrlItemData*)GetItemData (item_id);
	client_pt = event.GetPoint ();
	switch (item_data->m_type)
	{
	case FILE_TREE_CTRL_ITEM_TYPE__FILE:
	    ShowMenuFile (item_id, client_pt);
		break;
	case FILE_TREE_CTRL_ITEM_TYPE__WAVE:
	    ShowMenuWave (item_id, client_pt);
		break;
	default:
		Console_Error ("FileTreeCtrl::OnItemRClick () :  item have unknown type %d", item_data->m_type);
	}

//	wxLogMessage(wxT("Item \"%s\" right clicked"), item ? item->GetDesc() : _T(""));

finish:
	event.Skip();
}

void FileTreeCtrl::OnSelChanging (wxTreeEvent& event)
{
// elemental 'unselect_others' is not available;
// key events may not go here properly, so put the selection blicking here - isn't good solution
#if 1
// var for the hack
	bool unselect_others;
// hack for hack :) (to avoid "warning C4700: local variable 'unselect_others' used without having been initialized")
	bool* bool_ptr;
	wxTreeItemId item_id;
	FileTreeCtrlItemData* item_data;
	wxArrayTreeItemIds selection;
	uint selected_num;
	int already_selected_type;
//	wxKeyEvent key_event;
//	int modifiers;
//	bool control_down;

// hooorible hack :)
// address from 'wxGenericTreeCtrl::DoSelectItem ()'
// avoid compiler warning
//	unselect_others = 0;
#if __WXDEBUG__ 
//	unselect_others = (&unselect_others)[0x01cc];
	bool_ptr = &unselect_others;
	unselect_others = bool_ptr[0x01cc];
#else
// todo
//	unselect_others = (&unselect_others)[0x01cc];
	bool_ptr = &unselect_others;
	unselect_others = bool_ptr[0x01cc];
#endif
	wxASSERT(! (*(char*)bool_ptr & 0xfe));
// always 0 (perhaps all key events broken somewhere (in my code))
#if 0
	key_event = event.GetKeyEvent ();
	control_down = key_event.ControlDown ();
	control_down = key_event.CmdDown ();
#endif
#if 0
	modifiers = key_event.GetModifiers ();
	control_down = modifiers & wxMOD_CONTROL;
#endif
#if 0
	if (! control_down)
// it isn't additional selection
		goto finish;
#endif
	if (unselect_others)
		goto finish;

	selected_num = GetSelections (selection);
// not happens
	if (! selected_num)
		goto finish;
// other items will be of the same type
	item_id = selection[0];
	if (! item_id.IsOk ())
		goto finish;
	item_data = (FileTreeCtrlItemData*)GetItemData (item_id);
	already_selected_type = item_data->m_type;

// the item, on which the right mouse button has been pressed
	item_id = event.GetItem ();
	if (! item_id.IsOk ())
		goto finish;
	item_data = (FileTreeCtrlItemData*)GetItemData (item_id);
	if (item_data->m_type != already_selected_type)
	{
		event.Veto();
		return;
	}
finish:
#endif
	event.Skip();
}

// catch, for file selection
void FileTreeCtrl::OnLMouseDown (wxMouseEvent& event)
{
	event.Skip ();
	if (event.m_controlDown)
// simply invert
	{
		m_file->m_is_selected = ! m_file->m_is_selected;
		SelectionSet ();
		return;
	}
//	SelectionClearAll ();
	SendFileSelectionsResetEvent ();
	m_file->m_is_selected = 1;
	SelectionSet ();
}

void FileTreeCtrl::OnManageWaves (wxCommandEvent& WXUNUSED(event))
{
	Waves_Manage ();
}

void FileTreeCtrl::OnFileProperties (wxCommandEvent& WXUNUSED(event))
{
	DialogFileProperties* dialog_file_properties;

	dialog_file_properties = new DialogFileProperties (this, m_file);
	delete dialog_file_properties;
//	Reinit ();
}

void FileTreeCtrl::OnDeleteWaves (wxCommandEvent& WXUNUSED(event))
{
	Waves_Delete ();
}

void FileTreeCtrl::OnSamplesInsert (wxCommandEvent& WXUNUSED(event))
{
	Waves_Samples_InsertRemove (1);
}

void FileTreeCtrl::OnSamplesRemove (wxCommandEvent& WXUNUSED(event))
{
	Waves_Samples_InsertRemove (0);
}

// *VK_RETURN is blocked in 'wxWindowMSW::MSWDefWindowProc ()'
void FileTreeCtrl::OnChar (wxKeyEvent& event)
{
	wxArrayTreeItemIds selection;
	int selected_num;
	wxTreeItemId item_id;
	FileTreeCtrlItemData* item_data;

// check - is it not the file item
	selected_num = GetSelections (selection);
// happens
	if (! selected_num)
		goto finish;
	item_id = selection[0];
	wxASSERT(item_id.IsOk ());
	item_data = (FileTreeCtrlItemData*)GetItemData (item_id);
//	goto finish;
	switch (item_data->m_type)
	{
	case FILE_TREE_CTRL_ITEM_TYPE__FILE:
		if (event.GetKeyCode () == WXK_INSERT)
		{
			Waves_Manage ();
			return;
		}
		break;
	case FILE_TREE_CTRL_ITEM_TYPE__WAVE:
		if (event.GetKeyCode () == WXK_DELETE)
		{
			Waves_Delete ();
			return;
		}
		break;
	default:
		Console_Error ("FileTreeCtrl::OnChar () :  wrong selected item 0 type %d", item_data->m_type);
	}

finish:
	event.Skip ();
}

// ----- event handlers -----

