#pragma once

#include "types.h"


typedef long fix32;
typedef int64 fix64;

#define F2_0 0x200000000
#define F1_0 0x100000000
#define F0_1 (0x100000000 / 10)

#define F32_1_0 0x00010000

#define FIX32_TO_INT(_fix32_) ((int)((_fix32_) >> 16))
#define INT_TO_FIX32(_int_) ((fix32)_int_ << 16)
#define FIX64_TO_INT(_fix64_) ((int)((_fix64_) >> 32))
#define INT_TO_FIX64(_int_) ((fix64)(_int_) << 32)

#define FIX64_TO_FIX32(_fix64_) ((fix32)((_fix64_) >> 16))
#define FIX32_TO_FIX64(_fix32_) ((fix64)((_fix32_) << 16))

#define FIX64_FRAC(_fix64_) ((_fix64_) & 0x00000000ffffffff)

#define fix32div(_a_, _b_) ((fix32)(((__int64)(_a_) << 16) / (_b_)))
#define fix32mul(_a_, _b_) ((fix32)((__int64)(_a_) * (_b_) >> 16))
#define fix32frac(_a_) ((_a_) & 0x0000ffff)
// perversions :P
#define fix64mul32(_a_, _b_) ((_a_) * (_b_) >> 16)
#define fix64div32(_a_, _b_) (((_a_) << 16) / (_b_))
// 16 bits loss on the lower side
//#define fix64mul(_a_, _b_) (((_a_) >> 16) * ((_b_) >> 16))
// make 8 bits loss on the lower side, and 16 bit loss on the higher side
//#define fix64mul(_a_, _b_) ((((_a_) >> 8) * ((_b_) >> 8)) >> 16)
//#define fix64mul_int(_fix64_, _int_) (((_fix64_) >> 16) * ((fix64)(_int_) << 16))
