#pragma once

#include "wx/frame.h"
//#include "wx/splitter.h"
#include "project.h"
#include "display.h"
#include "window_files.h"
#include "window_splitter.h"

#include "menu_file.h"
#include "menu_edit.h"
#include "menu_view.h"
#include "menu_analyze.h"
#include "menu_process.h"
#include "menu_options.h"
#include "menu_help.h"


class Frame : public wxFrame
{
public:
// theoretically, belongs here; although from other sight - must belong at app
	Project m_project;
//	Display m_display;

	Frame ();
	virtual ~Frame ();
	void WndCheckPos (int& x, int& y, int& w, int& h);
	void OnceAfterAdd ();

	void OnSize (wxSizeEvent& event);
	void OnMove (wxMoveEvent& event);
	void OnChar (wxKeyEvent& event);
	void OnUpdateDisplay (wxNotifyEvent& event);
	void OnResetFileSelections (wxNotifyEvent& event);

// callbacks
	void OnQuit (wxCommandEvent& event);
//	void OnAbout (wxCommandEvent& event);
	void OnDelete (wxCommandEvent& event);
// +++ file +++
	void OnOpenAdditionally (wxCommandEvent& event);
	void OnSaveSelectedFiles (wxCommandEvent& event);
	void OnSaveAllFiles (wxCommandEvent& event);
	void OnCloseCurrent (wxCommandEvent& event);
// --- file ---
// +++ analyze +++
	void OnAnalyzeLevels (wxCommandEvent& event);
// --- analyze ---
// +++ process +++
//	void OnProcess_SampleRate_Half (wxCommandEvent& event);
//	void OnProcess_SampleRate_Double (wxCommandEvent& event);
//	void OnProcess_Resample (wxCommandEvent& event);
//	void OnProcess_Amplify_Double (wxCommandEvent& event);
// --- process ---
	void OnDispatchSimpleEventTo_WindowFiles (wxNotifyEvent& event);
// test
//	int FilterEvent (wxEvent& event);

private:
	wxMenuBar* m_menu_bar;
//	wxSplitterWindow* m_splitter;
	WindowSplitter* m_splitter1;
	WindowSplitter* m_splitter2;
	WindowFiles* m_window_files;
//	wxTextCtrl* m_console;
	Display* m_display;
//	wxTextCtrl* m_text;
//	wxCheckBox* m_check;
	Menu_File m_menu_file;
	Menu_Edit m_menu_edit;
	Menu_View m_menu_view;
	Menu_Analyze m_menu_analyze;
	Menu_Process m_menu_process;
	Menu_Options m_menu_options;
	Menu_Help m_menu_help;
// one of many small lacks of Windows, when OS have these values, but to get them isn't possible, and must watch self for them
	int m_x;
	int m_y;
	int m_w;
	int m_h;
	bool m_maximized;
	bool m_once_after_add;
//	bool m_had_waves;

	DECLARE_EVENT_TABLE()
};

