#pragma once
// OS unrelated enums here
// event ids, which should be given by the wxWidgets are in "events.h"

#include <wx/defs.h>


// not only frame, any ids relating at interaction with wxWidgets
// also exist DECLARE_EVENT_TYPE() way; and wxEVT_FIRST seems is for the internal use in DECLARE_EVENT_TYPE()
enum
{
// hehe, exactly good that wxID_HIGHEST is defined that way (because of enum lacks); the name of it actually is properly-equal to it's position
	WIDGETS_USER_ID_PREFIRST = wxID_HIGHEST,
	DUMMY0,
	DUMMY1,
	DUMMY2,
// yes, values of wxID_LOWEST is a bit crappy, due to it's definition through enum; and wxID_HIGHEST is accordingly displaced
//	FRAME__UPDATE_DISPLAY = wxID_HIGHEST + 1,
//	FRAME__UPDATE_DISPLAY,
//	FRAME__UPDATE_VIEW_FILES,
//	FRAME__RESET_FILE_SELECTIONS,
// simple - means EVT_NOTIFY which will not have any detailed userdata, but just event id
//	FRAME__DISPATCH_SIMPLE_EVENT_TO__WINDOW_FILES,
//	WINDOW_FILES__RESET_FILE_SELECTIONS,
// == file menu ==
	FRAME__NEW_ADDITIONALLY,
	FRAME__OPEN_ADDITIONALLY,
	FRAME__SAVE_SELECTED_FILES,
	FRAME__SAVE_ALL_FILES,
	FRAME__CLOSE_CURRENT,
	FRAME__QUIT,
// == edit menu ==
// == view menu ==
	VIEW_WAVE_SIMPLE,
	VIEW_WAVE_MIPMAP,
	VIEW_WAVE_FULL,
// == analyze menu ==
	FRAME__ANALYZE_LEVELS,
// == process menu ==
//	FRAME__PROCESS_AMPLIFY,
//	FRAME__PROCESS_SAMPLERATE_HALF,
//	FRAME__PROCESS_SAMPLERATE_DOUBLE,
//	FRAME__PROCESS_RESAMPLE,
//	FRAME__PROCESS_SAMPLERATE_DUPLICATE,
//	FRAME__PROCESS_AMPLIFY_DOUBLE,
	MENU_PROCESS__PROCESS_AMPLIFY,
	MENU_PROCESS__PROCESS_SAMPLERATE_HALF,
	MENU_PROCESS__PROCESS_SAMPLERATE_DOUBLE,
	MENU_PROCESS__PROCESS_RESAMPLE,
	MENU_PROCESS__PROCESS_SAMPLERATE_DUPLICATE,
	MENU_PROCESS__PROCESS_AMPLIFY_DOUBLE,
// == options menu ==
// will be moved out from here
	FRAME__DELETE,
// == help menu ==
	HELP_HELP,
	HELP_ABOUT,
	WIDGETS_USER_ID_LAST
};


// 'FileTreeCtrl'
enum
{
	FILE_TREE_CTRL__ID_MANAGE_WAVES,
	FILE_TREE_CTRL__ID_FILE_PROPERTIES,
	FILE_TREE_CTRL__ID_DELETE_WAVE,
	FILE_TREE_CTRL__ID_SAMPLES_INSERT,
	FILE_TREE_CTRL__ID_SAMPLES_REMOVE,
};

