// by Alexander Ilyin

#include "menu_analyze.h"
#include "ids.h"


Menu_Analyze::Menu_Analyze (wxFrame* frame, Project* project)
{
	m_menu = new wxMenu;
	m_proj = project;
	m_frame = frame;
}

Menu_Analyze::~Menu_Analyze ()
{
	;
}

void Menu_Analyze::Create ()
{
// what word "amplitude" means at all ?
	m_menu->Append (FRAME__ANALYZE_LEVELS, _T("&Levels"), _T("Analyze selected waves' max-min amplitude levels"));
//	m_menu->AppendSeparator ();
}

void Menu_Analyze::OnAnalyzeLevels ()
{
	uint i;
	char* buffer;
	char buffer1[256];
	double correlation;
	double db;
	wave_data_u_t level_totally;
	wxMessageDialog* mbox;

// test
//	for (i = 0; i < m_proj->m_waves_num; i++)
//		m_proj->m_wave_is_selected[i] = 1;

	m_proj->Analyze_Levels ();
// few tenth bytes for every string
	buffer = (char*)malloc (128 + 64 * m_proj->m_waves_num);
	if (! buffer)
		return;
	level_totally = -m_proj->m_level_totally_min;
	if (level_totally < (unsigned)m_proj->m_level_totally_max)
		level_totally = m_proj->m_level_totally_max;
// max value for signed data (which is completely reachable actually only for negative values)
	correlation = WAVE_HIGHEST_BIT_MASK;
	correlation = level_totally / correlation;
	db = log10 (correlation);
// by some cause, the Bels are the power for 'sqr (10.0)' and not '10.0' itself
	db *= 20;
	sprintf (buffer, "Analyzing relatively to maximal possible level (0.0 dB)\n");
	sprintf (buffer1, "Totally :  correlation %f, %f dB\n", correlation, db);
	strcat (buffer, buffer1);
	for (i = 0; i < m_proj->m_waves_num; i++)
	{
		Wave* wave;
		if (! m_proj->m_wave_is_selected[i])
			continue;
		wave = m_proj->m_waves[i];
		wave->m_level_max;
		level_totally = -wave->m_level_min;
// careful, may stop working properly on MSVC compiler, if will be less than 32 bit
		if (level_totally < (unsigned)wave->m_level_max)
			level_totally = wave->m_level_max;
		correlation = WAVE_HIGHEST_BIT_MASK;
		correlation = level_totally / correlation;
		db = log10 (correlation);
		db *= 20;
		sprintf (buffer1, "%02u :  correlation %f, %f dB", i, correlation, db);
		strcat (buffer, buffer1);
		strcat (buffer, "\n");
	}
	mbox = new wxMessageDialog (m_frame, buffer, "Level analyzation results", wxOK);
	mbox->ShowModal ();
	free (buffer);
}

