#pragma once

#include "wx/menu.h"
#include "project.h"
#include "dialog_resample.h"


//class Menu_Process
class Menu_Process : public wxMenu
{
public:
// allocated here, freed at menu bar delete time
	wxMenu* m_menu;
	Project* m_proj;
	wxFrame* m_frame;

	Menu_Process (wxFrame* frame, Project* project);
	~Menu_Process ();
	void Create ();
	void Config_Read (wxConfigBase* config);
	void Config_Write (wxConfigBase* config);

private:
	void SendUpdateEvent ();
// + callbacks +
	static void Callback_SampleRate_Half (void* void_ptr, Wave* wave);
	static void Callback_SampleRate_Double (void* void_ptr, Wave* wave);
	static void Callback_Resample (void* void_ptr, Wave* wave);
// *simplified; really - should use rational fraction
	static void Callback_Amplify_Double (void* void_ptr, Wave* wave);
// - callbacks -
public:
// + events +
//	void OnAbout (wxCommandEvent& event);
	void OnProcess_SampleRate_Half (wxCommandEvent& event);
	void OnProcess_SampleRate_Double (wxCommandEvent& event);
	void OnProcess_Resample (wxCommandEvent& event);
// *simplified
	void OnProcess_Amplify_Double (wxCommandEvent& event);
// - events -

private:
	DialogResample* m_dialog_resample;

	DECLARE_EVENT_TABLE()
};

