#pragma once

#include "wx/menu.h"
#include "project.h"
#include "dialog_resample.h"
#include "display.h"


//class Menu_View
class Menu_View : public wxMenu
{
public:
	Menu_View (wxFrame* frame, Project* project);
	~Menu_View ();
	void Create ();
	void Config_Read (wxConfigBase* config);
	void Config_Write (wxConfigBase* config);
	void Init (Display* display);
	void SetCheckboxes_WaveView ();
	void OnCommand (wxCommandEvent& event);

// allocated here, freed at menu bar delete time
//	wxMenu* m_menu;

#if 0
private:
// + callbacks +
	static void Callback_SampleRate_Half (void* void_ptr, Wave* wave);
	static void Callback_SampleRate_Double (void* void_ptr, Wave* wave);
	static void Callback_Resample (void* void_ptr, Wave* wave);
// - callbacks -
public:
// + events +
//	void OnAbout (wxCommandEvent& event);
	void OnProcess_SampleRate_Half ();
	void OnProcess_SampleRate_Double ();
	void OnProcess_Resample ();
// - events -
#endif

private:
	wxFrame* m_frame;
	Display* m_display;
	Project* m_proj;
	wxMenu* m_menu_wave;
	wxMenuItem* m_menuitem_view_wave_simple;
	wxMenuItem* m_menuitem_view_wave_mipmap;
	wxMenuItem* m_menuitem_view_wave_full;
//	DialogResample* m_dialog_resample;

	DECLARE_EVENT_TABLE()
};

