#pragma once

#include "wx/wx.h"
// warning C4244: '=' : conversion from '__int64' to 'int', possible loss of data
#pragma warning(default:4244)
#include "file.h"
#include "wave.h"


class Project
{
public:
	Project ();
	~Project ();
	bool File_Add (File* file, uint insert_at_ix);
	bool File_Remove (uint position_at_ix);
	bool File_ParseAndAdd (wxString& file_name, File*& file);
	bool File_CreateAndLoadWaves (File* file);
	void File_ParseAddAndLoad (wxString& file_name);
	void FilesAdd (wxArrayString& paths);
//	void FileSave ();
	void FileSave (uint file_ix);
//	void FilesSave ();
//	void WaveClose ();
//	void FileClose (uint file_ix);
	void FileDelete (uint file_ix);
	bool SelectedWaves_CheckAndReport ();
// +++ analyze +++
	void Analyze_Levels ();
// --- analyze ---
// +++ process +++
	void UpdateFiles (uint wave_ix);
	void SelectedWaves_IterateFunction (void(* func) (void* void_ptr, Wave* wave), void* void_ptr);
	bool SelectedWaves_GetSingleSamplerate (uint& samplerate);
#if 0
	void Process_Samples_Half (bool average_level, bool downrate);
	void Process_Samples_Double (bool uprate, bool duplicate, bool extend_begin, bool extend_end);
	void Process_Resample (uint cycle_size_out, uint cycle_size_in, bool change_rate);
#endif
// --- process ---

	File* m_files[PROJECT_FILES_MAX];
	Wave* m_waves[PROJECT_WAVES_MAX];
	uint m_files_num;
	uint m_waves_num;
// some changes in the project structure
	bool m_have_changes;
// I don't think it must be here; looks more properly would be placed in wave class
	bool m_wave_is_selected[PROJECT_WAVES_MAX];
//	bool m_file_is_selected[PROJECT_FILES_MAX];
// +++ analyze +++
	wave_data_t m_level_totally_max;
	wave_data_t m_level_totally_min;
// --- analyze ---
// +++ settings +++
// in case if a file have information, which relates to a wave - it must be updated separately (samples num, for example)
	bool m_update_files_after_waves_processing;
// --- settings ---

// + just storage +
// not actually necessary
//	int m_files_opened;
// - just storage -
};

