// by Alexander Ilyin

#include "statusbar.h"
#include "macros.h"
#include "error.h"


// instantiate one, for access
StatusBar* status_bar = 0;


BEGIN_EVENT_TABLE(StatusBar, wxStatusBar)
	EVT_SIZE(StatusBar::OnSize)
END_EVENT_TABLE()

#define STATUSBAR_WINDOWS 4


StatusBar::StatusBar (wxWindow* parent)
:
wxStatusBar (parent)
{
	SetFieldsCount (STATUSBAR_WINDOWS);
}

#if 0
void StatusBar::StatusBar (wxWindow* parent)
{
	Create (STATUSBAR_WINDOWS);
}
#endif

// +++ events +++
// --- events ---

// hmmm, appears not in use
//void StatusBar::UpdateClock ()
void StatusBar::UpdateValues ()
{
#if 0
	SetStatusText ("123", 0);
	SetStatusText ("456", 1);
	SetStatusText ("789", 2);
#endif
	SetStatusText ("", 0);
	SetStatusText ("", 1);
	SetStatusText ("", 2);
}

#if 0
void StatusBar::SetText (uint wnd_ix, const char* text)
{
	Assert(wnd_ix < STATUSBAR_WINDOWS);
	SetStatusText (text, wnd_ix);
}
#endif

void StatusBar::SetText (uint wnd_ix, const char* format, ...)
{
	static char buffer[1024];
	va_list argptr;

	va_start (argptr, format);
	_vsnprintf (buffer, sizeof(buffer) - 1, format, argptr);
	va_end (argptr);
//	SetText (wnd_ix, buffer);
	Assert(wnd_ix < STATUSBAR_WINDOWS);
	SetStatusText (buffer, wnd_ix);
}

void StatusBar::OnSize (wxSizeEvent& event)
{
	int height;
	int widths[STATUSBAR_WINDOWS];

// that should roughly say what the size the font will have
	GetClientSize (0, &height);
	widths[0] = height * 4;
	widths[1] = height * 6;
	widths[2] = height * 7;
	widths[3] = -1;
	SetStatusWidths (NUMOF(widths), widths);

	event.Skip ();
}

