// by Alexander Ilyin
// *original belongs at the Dragging Watcher project

#ifndef STRING_H
#define STRING_H


#include <stdio.h>

#include "types.h"


bool Strncpy (char* dest, const char* source, size_t buffer_size);
bool WStrncpy (wchar_t* dest, const wchar_t* source, size_t buffer_size);
// copy, and return 0, if it is not alphanum or does not fit into buffer
bool Str_IsAlphaNum (const char* str);
// insert one char in a string in sized buffer
bool StringN_InsertChar (char* string, uint string_buffer_size, char char_insert, uint position);
// delete one char, to the left from the position
bool String_BackspaceChar (char* string, uint position);
// delete one char, on the position
bool String_DeleteChar (char* string, uint position);
// convert Unicode string to ANSI format
bool String_UnicodeToANSI (char* ansi_string, int buffer_size, ushort* unicode_string, int string_size);

bool Snprintf (char* string, uint buffer_size, const char* format, ...);
#define Snprintf 0 <= _snprintf

#endif // STRING_H
