//

#include "window_files.h"
//#include "wx/generic/treectlg.h"
//#include "wx/dcclient.h"
//#include "wx/dcmemory.h"
#include "wx/wx.h"
#include "ids.h"
#include "error.h"
#include "events.h"

// "treetest" sample :  'wxTreeCtrl' on 'wxPanel', 'wxPanel' on 'wxFrame'


DEFINE_EVENT_TYPE(wxEVT__WINDOW_FILES__RESET_FILE_SELECTIONS)

BEGIN_EVENT_TABLE(WindowFiles, wxScrolledWindow)
//	EVT_NOTIFY(WINDOW_FILES__RESET_FILE_SELECTIONS, wxID_ANY, WindowFiles::OnResetFileSelections)
	EVT_NOTIFY(wxEVT__WINDOW_FILES__RESET_FILE_SELECTIONS, wxID_ANY, WindowFiles::OnResetFileSelections)
END_EVENT_TABLE()


//wxTreeCtrl* g_treectrl_test;
//wxGenericTreeCtrl* g_treectrl_test;
//FileTreeCtrl* g_treectrl_test;


//// 'wxTreeCtrl' requires a panel, otherwise it doesn't receives (mouse) controls
WindowFiles::WindowFiles (wxWindow* parent, Project* project)
	:
	wxScrolledWindow (parent, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxHSCROLL | wxVSCROLL)
//	wxScrolledWindow (parent)
//	wxPanel (parent)
//	wxPanel (parent, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxHSCROLL | wxVSCROLL)
{
	m_window_parent = parent;
	m_proj = project;
}

void WindowFiles::TreeControl_New (File* file, int ix)
{
	FileTreeCtrl* tree_ctrl;
	int offset_x;

	offset_x = MY_TREE_CTRL_WIDTH + 0;
	offset_x *= ix;
// *theoretically must be placed upon 'wxPanel'
	tree_ctrl = new FileTreeCtrl (file, m_proj, this, wxID_ANY, wxPoint (offset_x, 0), wxSize (MY_TREE_CTRL_WIDTH, 100));
	m_tree_ctrls.push_back(tree_ctrl);
}

void WindowFiles::TreeControls_Create (File* files[], int files_num)
{
	int i;
	int offset_x;

// todo :  define treectrl sizes

	for (i = 0; i < files_num; i++)
	{
		TreeControl_New (files[i], i);
	}
	offset_x = MY_TREE_CTRL_WIDTH + 0;
	offset_x *= files_num;
	SetVirtualSize (offset_x, 100);
	SetScrollRate (10, 10);
}

void WindowFiles::TreeControls_Remove ()
{
// "Destroys all children of a window."
	DestroyChildren ();
// "Notice that this function is mostly internal to wxWidgets and shouldn't be called by the user code."
//	RemoveChild (wxWindow* child);
}

// find out whole subwindow width and height (requires test painting)
void WindowFiles::DefineSize ()
{
#if 0
	wxSize size;

// only this returns right or almost right value (it differs by 4x4 from the 'SetSize ()' one)
// paint not makes this value smaller, only makes bigger when necessary
	size = m_tree_ctrl->GetVirtualSize ();
// no scrollbars
//	size.x += 12;
//	size.y += 4;
// no scrollbars
//	size.x += 4;
//	size.y += 20;
// with scrollbars
	size.x += 11;
	size.y += 19;
	m_tree_ctrl->SetSize (size);
//	size.x += 32;
//	size.y += 32;
	SetVirtualSize (size);
//	SetSize (size);
	size = m_tree_ctrl->GetSize ();
	size = m_tree_ctrl->GetClientSize ();
	Refresh ();
#if 0
//	wxDC dc (m_tree_ctrl);
	wxClientDC dc (m_tree_ctrl);
//	wxPaintDC dc (m_tree_ctrl);
	PrepareDC (dc);
	size = dc.GetSize ();
	size.x = dc.MaxX () - dc.MinX ();
	size.y = dc.MaxY () - dc.MinY ();
//	size = dc.GetVirtualSize ();
//	size = dc.GetClientSize ();
// initiate redraw
	m_tree_ctrl->Refresh ();
// make redraw
	m_tree_ctrl->Update ();
#endif
#endif
}

void WindowFiles::Reinit (File* files[], int files_num)
{
	TreeControls_Remove ();
	TreeControls_Create (files, files_num);
	DefineSize ();
#if 0
	m_tree_ctrl->SetSize (m_tree_ctrl->GetSize ());
	SetSize (m_tree_ctrl->GetSize ());
	m_tree_ctrl->Update ();
	Update ();
	m_tree_ctrl->UpdateWindowUI ();
	UpdateWindowUI ();
#endif
}

// is not requested :/
void WindowFiles::OnResetFileSelections (wxNotifyEvent& event)
{
	vector_filetreectrl_t::iterator i;

	for (i = m_tree_ctrls.begin(); i != m_tree_ctrls.end(); i++)
	{
		FileTreeCtrl* file_tree_ctrl;
		File* file;
		file_tree_ctrl = *i;
		Assert(file_tree_ctrl);
		file = file_tree_ctrl->m_file;
		Assert(file);
		file->m_is_selected = 0;
		file_tree_ctrl->SelectionSet ();
	}
}

