#pragma once

#include "wx/wx.h"
//#include "wx/frame.h"
#include "wx/splitter.h"
#include "wx/config.h"
//#include <string>
//using namespace std;

typedef unsigned int uint;

enum
{
	SPLIT_HORIZONTALLY,
	SPLIT_VERTICALLY
};


class WindowSplitter : public wxSplitterWindow
{
public:
//	WindowSplitter (wxFrame* parent);
	WindowSplitter (wxWindow* parent, char* name);
// set, but do not apply
	void Windows_Set (wxWindow* wnd0, wxWindow* wnd1, byte split_direction, bool is_split = 1, bool from_end = 0, uint offset = 100, byte active_window = 0);
// + config +
// let user read config and apply current settings independently
	void Config_Read (wxConfigBase* config);
	void Config_Write (wxConfigBase* config);
//	void Values_Get ();
//	void Values_Set ();
	void Values_Apply ();
// - config -
	bool OnSashPositionChange (int newSashPosition);
	void OnSize (wxSizeEvent& event);

#if 0
    // event handlers
    void OnPositionChanged(wxSplitterEvent& event);
    void OnPositionChanging(wxSplitterEvent& event);
    void OnDClick(wxSplitterEvent& event);
    void OnUnsplitEvent(wxSplitterEvent& event);
#endif

private:
	void Name_Set (char* name);
	void NewSashPosition (int pos);

private:
//	wxFrame* m_frame;
	wxWindow* m_window_parent;
// must catch windows; will be necessary to store settings, and the Widgets way of applying windows to a splitter is very different
	wxWindow* m_window_0;
	wxWindow* m_window_1;
//#define WINDOW_SPLITTER_NAME_SIZE 32
// *user's job to check, that these names wouldn't collide
//	char m_name[WINDOW_SPLITTER_NAME_SIZE];
//	string m_name;
	wxString m_name;
// split vertically, otherwise - horizontally
//	bool m_vertically;
// 0 - horizontally (left and right), 1 - vertically (top and bottom)
	byte m_split_direction;
	bool m_is_split;
// in case, if will not be split
	byte m_active_window;
// position is from end
	bool m_from_end;
// position
	uint m_splitter_pos;

	DECLARE_EVENT_TABLE()
	DECLARE_NO_COPY_CLASS(WindowSplitter)
};

