#pragma once

#include "types.h"
#include "wx/colour.h"


class wxColourDiff
{
public:
	wxColourDiff::wxColourDiff ()
	{
		m_r = 0;
		m_g = 0;
		m_b = 0;
	}
	wxColourDiff::wxColourDiff (int r, int g, int b)
	{
		m_r = r;
		m_g = g;
		m_b = b;
	}
	void Set (int r, int g, int b)
	{
		m_r = r;
		m_g = g;
		m_b = b;
	}
	int m_r;
	int m_g;
	int m_b;
};

class wxColourM : public wxColour
{
public:
#if 1
	wxColour operator = (const wxColour& colour) const
//	wxColour operator = (const wxColour& colour)
	{
// ask another operator, the one which actually is in the 'wxObject'
		*(wxColour*)this = colour;
// no
//		(wxColour)*this = colour;
// dead loop
//		*this = colour;
//		wxColour::(*this) = colour;
		return colour;
	}
#endif
	byte ComponentAdd (int component, int add)
	{
		component += add;
		if (component > 255)
			component = 255;
		if (component < 0)
			component = 0;
		return (byte)component;
	}
	void Add (int r, int g, int b)
	{
		*this += wxColourDiff (r, g, b);
	}
// error
//	wxColour operator + (const wxColourDiff& colour_diff) const
	wxColour operator + (const wxColourDiff& colour_diff)
	{
		byte r;
		byte g;
		byte b;
		int diff;

		r = Red ();
		g = Green ();
		b = Blue ();
		diff = colour_diff.m_r;
		r = ComponentAdd (r, diff);
		diff = colour_diff.m_g;
		g = ComponentAdd (g, diff);
		diff = colour_diff.m_b;
		b = ComponentAdd (b, diff);
//		Set (r, g, b);
		return wxColour (r, g, b);
	}
	wxColour operator - (const wxColourDiff& colour_diff)
	{
		byte r;
		byte g;
		byte b;
		int diff;

		r = Red ();
		g = Green ();
		b = Blue ();
		diff = colour_diff.m_r;
		r = ComponentAdd (r, -diff);
		diff = colour_diff.m_g;
		g = ComponentAdd (g, -diff);
		diff = colour_diff.m_b;
		b = ComponentAdd (b, -diff);
		return wxColour (r, g, b);
	}
	void operator += (const wxColourDiff& colour_diff)
// error
//	void operator += (const wxColourDiff& colour_diff) const
	{
		*this = *this + colour_diff;
	}
	void operator -= (const wxColourDiff& colour_diff)
	{
		*this = *this - colour_diff;
	}
};

